      SUBROUTINE BM1MAG(EC,KSTHE,NSTHE,JTOT,KSTGS,NSTGS,JTOTI,
     X			BM,MCH,A1,A3,Z3,NFI,TRWF,
     X			JTARG,QM0)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      REAL*8 JTOT,JTOTI,JTARG(10),JCORI,JCORF
C    ***********************************************************
C  CALCULATION OF BM1 FOR DISCRETISED EIGENSTATE OF REACTION
C  PRODUCTS FOR 3-BODY CONTINUUM
C	Assuming all wavefunctions are in T basis (3)
C
C    ***********************************************************
C *** K,L,S,L1,L2,2*S1,2*S2 - QUANTUM NUMBER    IN ARRAY
      INTEGER KSTHE(MCH,7),KSTGS(NSTGS,7)
      DIMENSION TRCHAN(MCH,MCH),TRWF(MCH,MCH),BMA(3)
      INTEGER PHASE
	LOGICAL TR(0:3)
	TR(0:3) = .false.
	TR(0)= .true.
	TR(1)= .true.
	TR(2)= .true.
	TR(3)= .true.
	Z = 0d0
	PI = 4d0*atan(1d0)
C######################################################################
      A2 = A1
      ASUM = A1 + A2 + A3
      S1 = 0.5D0
      S2 = 0.5D0
	GN = -3.826  !!!! NEUTRON !!!!
CC
C ***   LL - MULTIPOLARITY OF TRANS = 1
      LL = 1
        WRITE(64,151) LL
  151 FORMAT(3X,'B(M',I1,')   CALCUL. BEGINS          '/)

      AJ = 1.0
	    
	AL1 = GN * sqrt(3*3*2/(16*pi)) 
C
      IF(LL .EQ. 1) GO TO 2000
         GO TO 4000
C
C  ##########################################################################
C
C  ****  M1 TRANSITION
C
C ****** LOOP ON CONTNUUS SPECTRA  (RADIUS)
2000   AL1 = 1.D0/(4.D0*3.14159D0)*Z3**2*((A1+A2)/(ASUM*A3))
	 BMA(1:3) = 0.0
	 
       if(TR(1)) write(64,*) ' BM:',NSTHE,NSTGS,real(EC),MCH

       DO 2003  IF = 1,NSTHE
       KF = KSTHE(IF,1)
        LF = KSTHE(IF,2)
         ISF = KSTHE(IF,3)
          LXF = KSTHE(IF,4)
           LYF = KSTHE(IF,5)
             JNF = KSTHE(IF,6)
               ICF = KSTHE(IF,7)
	       JCORF= JTARG(ICF)
C ****** LOOP ON DISCRET SPECTRA
      DO 2002  II = 1,NSTGS
       KI = KSTGS(II,1)
        LI = KSTGS(II,2)
         ISI = KSTGS(II,3)
          LXI = KSTGS(II,4)
           LYI = KSTGS(II,5)
             JNI = KSTGS(II,6)
               ICI = KSTGS(II,7)
	       JCORI= JTARG(ICI)
C *****  GENERAL CHECK ON INACTIVE Q.N.

c      WRITE(64,1011) (KSTHE(IF,M1),M1=1,7),(KSTGS(II,M21),M21=1,7)
         IF(LXF .NE. LXI) GO TO 2002
         IF(LYF .NE. LYI) GO TO 2002
          IF(KF .NE. KI) GO TO 2002

      if(TR(1)) WRITE(64,10) (KSTHE(IF,M1),M1=1,7),(KSTGS(II,M1),M1=1,7)
10    FORMAT(/1X,' <GS ',7I3,' /START/  ',7I3,' > ')

C
C  First part BMA(1): neutron magnetic moment
	  IF(ICI .ne. ICF) GO TO 300  ! core state
          IF(LF .NE. LI) GO TO 300  ! L
	  
	  AL2 = 1 + (-1)**(ISI + ISF)
	  AL3 = (-1)**nint(JTOT-JTOTI)
	  AL4 = (2*JNF+1)*(2*ISI+1)*sqrt((2.*JTOT+1.)*(2*JTOTI+1.))
	  AL5 = RACAH(1d0,JNI+Z,JTOT,JCORI,JNF+Z,JTOTI)
	  AL6 = RACAH(1d0,0.5d0,ISF+Z,0.5d0,0.5d0,ISI+Z)
	  AL7 = RACAH(1d0,ISF+Z,JNI+Z,LI+Z,ISI+Z,JNF+Z)
	  W = AL1*AL2*AL3*AL4*AL5*AL6*AL7

C   *** CALC OF RADAL M.E.
C
	RSU = TRWF(IF,II)
	BMA(1) = BMA(1) + W * RSU

      if(tr(1))WRITE(64,20) 1,IF,II,
     * AL1,AL2,AL3,AL4,AL5,AL6,AL7,W,RSU,BMA(1)
20    FORMAT(' ',i1,': < ',I4,' |M1|',i4,'>=',7F8.4,f9.5,2f10.5)
C  *** PARTIAL
 300     CONTINUE
!  PART 2: CORE TRANSITIONS 
C
        IF(LF .NE. LI)   GO TO 500  ! L
	  IF(ISI .ne. ISF) GO TO 500  ! S
	  IF(JNI .ne. JNF) GO TO 500  ! J3
	  
	  AL2 = sqrt((2*JCORF+1)*(2*JTOT+1)*(2*JTOTI+1)/(2*JCORI+1.))
	  AL3 = QM0
	  AL4 = RACAH(1d0,JCORI,JTOT,JNI+Z,JCORF,JTOTI)
	  W = AL2*AL3*AL4
	  RSU = TRWF(IF,II)
	  BMA(2) = BMA(2) + W * RSU
	  
      if(tr(2))WRITE(64,320) 2,IF,II,AL1,AL2,AL3,AL4,W,RSU,BMA(2)
320    FORMAT(' ',i1,': < ',I4,' |M1|',I4,'>=',4F8.4,f9.5,2f10.5)

 
 500     CONTINUE
!  PART 3: SPATIAL 
	  IF(ISI .ne. ISF) GO TO 600  ! S
	  IF(ICI .ne. ICF) GO TO 600  ! core state

	 AL1 = sqrt(3d0/(4d0*pi)) * Z3/A3 * (A1+A2)/ASUM
	 AL2 = (-1)**(LI-LF+JNF-JNI) 
     x    * sqrt((2*LI+1.)*(2*LF+1.)*(2*JNF+1.)*(2*JNI+1.)*(2*JTOT+1)
     x           *(2*JTOTI+1)*(2*LYI+1.)*LYI*(LYI+1.))
       AL3 = RACAH(LYI+Z,LXI+Z,1d0,LF+Z,LI+Z,LYI+Z)
	 AL4 = RACAH(ISI+Z,JNI+Z,LF+Z,1d0,LI+Z,JNF+Z)
	 AL5 = RACAH(JCORI,JTOTI,JNF+Z,1d0,JNI+Z,JTOT)
	 W = AL1*AL2*AL3*AL4*AL5
	 RSU = TRWF(IF,II)
	 BMA(3) = BMA(3) + W * RSU

      if(tr(3))WRITE(64,520) 3,IF,II,
     * AL1,AL2,AL3,AL4,AL5,W,RSU,BMA(3)
520    FORMAT(' ',i1,': < ',I4,' |M1|',I4,'>=',5F8.4,f9.5,2f10.5)
 
 600	   CONTINUE

C
 2002     CONTINUE
 2003     CONTINUE
CC
C   **** SUM OF B(M1) CALCUL   ********************************
C
          BM = AJ * (BMA(1) + BMA(2) + BMA(3))**2

C ***** FOR PRINT
C
        WRITE(NFI,370) EC,BM,BMA(1:3)
 370     FORMAT(1X,f10.5,4G12.3)
        WRITE(64,371) EC,BM,BMA(1:3)
 371     FORMAT(' TO E =',f10.5', BM1 =',f10.5, 'from ',3f10.5)
 	 call flush(NFI)
C   **** END OF B(M1) CALCUL   ********************************
C
 4000   CONTINUE
 5000   RETURN
        END
