      SUBROUTINE CONSF(EC,LTR,ISIG,JTR,TT,KSTHE,NSTHE,JTOT,PARITY,
     X	 KSTGS,NSTGS,JTOTI,PARITI, PJ,MNM,MAXL,MLT,MJAC,NNP,WJ,NJAC,
     X	 PJ0,NN0,MLT0,	dSdE,TRCHAN,MCH,A1,A3,NFI)
C    ***********************************************************
C
C        CALCULATION OF STRENGTH FUNCTION TO 3-B DISCRETISED CONTINUUM
C		Modified from Sturm/consf45.f
c
C *** K,L,S,L1,L2,2*S1,2*S2 - QUANTUM NUMBER    IN ARRAYs KSTGS,KSTHE
C
c ------------ LI - bound     (initial) State
c ------------ HE - continuum (final)   State
C	Assuming all wavefunctions are in T basis (3)
c
C        STRENGTH FUNCTION TO 3-B CONTINUUM  ARE in  FUR(*)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
C
      REAL*8 JTOT,JTOTI
      INTEGER KSTHE(MCH,7),KSTGS(NSTGS,7)
      DIMENSION PJ(0:MNM,0:MAXL,-MLT:MLT,MJAC),TRCHAN(MCH,MCH),WJ(MJAC),
     &    PJ0(0:MNM,0:MAXL,-MLT0:MLT0,MJAC)
      INTEGER PHASE,PARITY,PARITI,TT

C *******************************************************************
c ---------  Reynal-Revai Coefficients
C
      COMMON/ROT/CPHI,SPHI,TPHI,A(499,29),JO11,JO12

       DIMENSION RRCLI(30,30),RRCHE(30,30)
     * ,L1LIM(30,30),L2LIM(30,30),L1HEM(30,30),L2HEM(30,30)
	DATA ECLAST/1e8/

	JLI = nint(JTOTI)
	IPLI= PARITI
	ITLI = TT
	JHE  = nint(JTOT)
	IPHE = PARITY
	ITHE = TT
      A2 = A1
C
      S1 = 0.5D0
      S2 = 0.5D0
       MJLI = 0
       MJ   = 0 
       MJHE = 0
C

C
C  *****  ANGULAR AND SPIN LOOPS ********
C  *****
      INOR  = 2
C     INOR  = 1 + (-1)**(ISLI+ISHE+     ITHE+ITLI)
C       IF(INOR .EQ. 0) GO TO 9902
C  *****
C  *****  NUCLEONS CASE          ********
C
           ASUM =  A1 + A3 +A2
           ALF2 = (A1 + A3)/ASUM/A2
           ALF3 = (A1 + A2)/ASUM/A3
           ALF  = ALF2
           ALFSQ= DSQRT(ALF2)
C          IF(ALF1 .LT. ALF2) ALF = ALF1
c
           J  = JTR
           L  = LTR
C ___________________________________________________________________
c
c  ***   Initial state loop 
C
	 FUR = 0.0
c	 write(3,*) ' CONSF:',NSTGS,NSTHE,TT,MCH,NNP,NN0
c        write(3,*) ' MNM,MAXL,MLT,MJAC,NJAC',MNM,MAXL,MLT,MJAC,NJAC
c	 write(3,*) ' CONSF:',A1,A2,A3,ASUM
         DO 1101 NSL = 1,NSTGS
C
c     WRITE(3,100) (KSTGS(NSL,M21),M21=1,7)
      KLI = KSTGS(  NSL,1)
       LLI = KSTGS(  NSL,2)
        ISLI = KSTGS(  NSL,3)
         L1LI = KSTGS(  NSL,4)
           L2LI = KSTGS(  NSL,5)
	if(NSL.eq.0.and.EC.lt.ECLAST)  then
	write(99,*) (KLI-L1LI-L2LI)/2,L1LI,L2LI,NN0,
     x				(L1LI-L2LI+NN0)/2
	do M=1,NJAC,5
	PJ2 = PJ0((KLI-L1LI-L2LI)/2,L1LI,(L1LI-L2LI+NN0)/2,M)
	write(99,*) ' K,M,PJ:',KLI,M,PJ2
	enddo
	ECLAST = EC
	endif

        CPHI=DSQRT(.5D0*A3/(A3+A1))
        SPHI=DSQRT(.5D0*ASUM/(A3+A1))
        if(A3.gt.999.) then
           CPHI=DSQRT(.5D0)
           SPHI=DSQRT(.5D0)
          endif
        TPHI=SPHI/CPHI

      CALL RRCOE(KLI,LLI,L1LI,L2LI)
        K    =  KLI
         N=  LLI
         L1  = L1LI
         L2  = L2LI
         NNKL= KLI - LLI
      NN=NNKL-2*(NNKL/2)

      JL11   =  JO11
      JL12   =  JO12
      DO 91   M1=1,JO11
      DO 91   N1=1,JO12
      L1=(K-(N-NN))/2+N1-M1
      L2=(K+(N-NN))/2-N1-M1+2
       L1LIM (M1,N1) =   L1
       L2LIM (M1,N1) =   L2
        RRCLI(M1,N1) = A(M1,N1)
C
 401  FORMAT(10X,2I3,D15.5)
 91   CONTINUE
c	write(3,*) ' RRCLI done'
c
c __________________________________________________________________
C
C  **** LOOP ON FINAL (RADIAL) QUANT. NUMBERS ****
C
         DO 1102 NSH = 1,NSTHE
C
      KHE = KSTHE(  NSH,1)
       LHE = KSTHE(  NSH,2)
        ISHE = KSTHE(  NSH,3)
         L1HE = KSTHE(  NSH,4)
           L2HE = KSTHE(  NSH,5)
c      IF((KLI.GT.4) .AND. (KHE.GT.4)) GO TO 1102
C  *****
      JNOR  = 1 + (-1)**(ISLI+ISHE+     ITHE+ITLI)
	PHASE = (-1)**nint(LLI+ISLI- JTOTI + LHE+ISHE-JTOT)
c      WRITE(3,1011) (KSTGS(NSL,M21),M21=1,7),(KSTHE(NSH,M11),M11=1,7)
c     x			,JNOR,PHASE
1011  FORMAT(1X,' < GS ',7I3,' /START/  ',7I3,' > ',2I2)
        IF(JNOR .EQ. 0) GO TO 1102
C  *****
C
        CPHI=DSQRT(.5D0*A3/(A3+A1))
        SPHI=DSQRT(.5D0*ASUM/(A3+A1))
        if(A3.gt.999.) then
           CPHI=DSQRT(.5D0)
           SPHI=DSQRT(.5D0)
          endif
        TPHI=SPHI/CPHI
 
      CALL RRCOE(KHE,LHE,L1HE,L2HE)
        K    =  KHE
         N=  LHE
         L1  = L1HE
         L2  = L2HE
         NNKL= KHE - LHE
      NN=NNKL-2*(NNKL/2)

      JH11   =  JO11
      JH12   =  JO12

      DO991   M1=1,JO11
      DO991   N1=1,JO12
      L1=(K-(N-NN))/2+N1-M1
      L2=(K+(N-NN))/2-N1-M1+2
        RRCHE(M1,N1) = A(M1,N1)
       L1HEM (M1,N1) =   L1
       L2HEM (M1,N1) =   L2
C
c      WRITE (7,401) L1,L2,A(M1,N1)
c      WRITE (6,401) L1,L2,A(M1,N1)
C401  FORMAT(10X,2I3,D15.5)
991   CONTINUE
 112  CONTINUE
c	write(3,*) ' RRCHE done for ',NSH

C     JH11   =  JO11
C     JH12   =  JO12
         NNKLL= KLI - LLI
      NNLI=NNKLL-2*(NNKLL/2)
      DO891   M1=1,JL11
      DO891   N1=1,JL12
      L1LI1=  L1LIM(M1,N1)
      L2LI2=  L2LIM(M1,N1)
         NNKLH= KHE - LHE
      NNHE=NNKLH-2*(NNKLH/2)
      DO791   J1=1,JH11
      DO791   I1=1,JH12
      L1HE1=  L1HEM(J1,I1)
      L2HE2=  L2HEM(J1,I1)
C     WRITE(3,8642)KLI,LLI,ISLI,L1LI1
c       WRITE(3,4647) L1LI1,L2LI2,LLI,ISLI,JLI,MJLI
c       WRITE(3,4646) L1HE1,L2HE2,LHE,ISHE,JHE,MJHE
c       WRITE(7,4647) L1LI1,L2LI2,LLI,ISLI,JLI,MJLI
c       WRITE(7,4646) L1HE1,L2HE2,LHE,ISHE,JHE,MJHE

C
        IF(L1HE1 .NE. L1LI1)GO TO 791
      CALL ANGSPI2(S1,S2,L1HE1,L2HE2,LHE,ISHE,JHE,MJHE,L ,ISIG,J,MJ,
     *                  L1LI1,L2LI2,LLI,ISLI,JLI,MJLI,AS)
	
c      WRITE(3,4646) L1HE1,L2HE2,LHE,ISHE,JHE,MJHE
c4646  FORMAT(1X,'<  L1HE1,L2HE2,LHE,ISHE,JHE,MJHE =',6I3,' |')
c      WRITE(3,4648) L,ISIG,J  ,MJ
c4648  FORMAT(1X,'|  L  ,ISIG,J  ,MJ   =',4I3,' |')
c      WRITE(3,4647) L1LI1,L2LI2,LLI,ISLI,JLI,MJLI
c4647  FORMAT(1X,'|  L1LI1,L2LI2,LLI,ISLI,JLI,MJLI =',6I3,' >')
c      IF((L.EQ.0).AND.(ISIG.EQ.0)) AS = DABS(AS)
c      WRITE(3,4649) AS
c4649  FORMAT(1X,'=',G12.3/)

       IF(ABS(AS) .LT. 1.D-10) GO TO 791
C
C HYPERANGLE  INTEGRAL 
	UOUT = 0.d0

      DO 620 M=1,NJAC
c EFADDX:
	PJ1 = PJ((KHE-L1HE1-L2HE2)/2,L1HE1,(L1HE1-L2HE2+NNP)/2,M)
	PJ2 = PJ0((KLI-L1LI1-L2LI2)/2,L1LI1,(L1LI1-L2LI2+NN0)/2,M)

c	write(3,*) ' At M=',M,' WJ,PJ1,2 =',real(WJ(M)),
c    x		real(PJ1),real(PJ2)
      UOUT=UOUT+ PJ1*PJ2 * WJ(M)
 
620   CONTINUE


C RADIAL INTEGRAL .1 -  TO RMAX
	SU = TRCHAN(NSH,NSL)

	SU = SU*PHASE

ccc          WRITE(3,1120)KHE,LHE,L1HE1,L2HE2,UOUT,SU,K1,LV,L1,L2
ccc          WRITE(3,1120)KHE,LHE,L1HE1,L2HE2,
ccc     X                 AS,RRCHE(J1,I1),RRCLI(M1,N1),K1,LV,L1,L2
1120  FORMAT(' <HE:K,LL,L1,L2=',4I2,'|NORM=',2G11.3,'|LI: ',4I2,'>')
c     WRITE(3,100) (KSTGS(NSL,M21),M21=1,7),L,ISIG,J,
c    x		   (KSTHE(NSH,M11),M11=1,7),SU,UOUT,AS,PHASE
 100  FORMAT(' <GS ',7I2,' |S',3I1,'|',7I2,'>=',3G12.4,I2)

      SU = SU*UOUT 

       FUR = FUR + 
     *       SU*AS*RRCHE(J1,I1)*RRCLI(M1,N1) * INOR

791   CONTINUE
891   CONTINUE

c *** End of continuum   (fin) loop

1102  CONTINUE

c *** End of bound state (ini) loop
1101  CONTINUE



c     WRITE(3,1518) JHE,MJHE,L,ISIG,J,MJ,JLI,MJLI
1518  FORMAT(1X,'<JF,MJF=',2I3,'|L, S ,J,MJ=',4I3,'|JI,MJI=',2I3,'>'/)
      AC= (-1)**(-JLI+J-MJHE)*DSQRT(2.D0*JHE + 1.D0)
       AC= WIG(2*JLI,2*J,2*JHE,2*MJLI,2*MJ ) * AC
c     WRITE(3,1918) JLI,MJLI,J,MJ,JHE,MJHE,AC
1918  FORMAT(1X,'<JL,MJL=',2I3,'J,MJ=',2I3,'|JH,MJH=',2I3,'>=',F5.3/)

           dSdE =FUR**2 
c
c *** Printout of strength functions:

       WRITE(NFI,9515) ec,dSdE
C
 9515 FORMAT(3X,f8.3, g14.4) 
      RETURN
9902   WRITE(3,9912)
       WRITE(6,9912)
9912   FORMAT(1X,' !!!!  ERROR :  SLI + SHE + TLI+THE ODD !'/)
      RETURN
      END
c
c
c ##########################################################################
c ##########################################################################
c
      SUBROUTINE ANGSPI2(S1,S2,L1H,L2H,LHE,ISHE,JHE,MJHE,L ,ISIG,J,MJ,
     *                  L1L,L2L,LLI,ISLI,JLI,MJLI,AS)
        IMPLICIT REAL*8(A-H,O-Z)
C *********************************************************************
C       SPIN - ANGULAR MATRIX ELEMENT FOR DENSITY OPERATOR            *
C               < L,M, SIG,M(SIG)/J,M(J)>                             *
C             IT ACTS ON A SUBSYSTEM 2    (L1H = L1L)                 *
C          CASE OF NUCLEON  S1 = S2 = 1/2      *
C *********************************************************************
C                                                                     *
        IF((MJLI + MJ ) .NE. MJHE) GO TO 1000
            PI = 3.14159
        IF(L .NE. 0)  GO TO 100
        IF(L2H .NE. L2L) GO TO 1000
        IF((L .EQ. 0)  .AND.( ISIG .EQ.0))GO TO 1003
 100     RMES =  DSQRT(6.D0)
        IF(ISIG .EQ. 0) RMES = DSQRT( 2.D0*S1 + 1.D0)
         RMEL =  DSQRT(  2* L2H+1.D0)
         RMEL =  DSQRT(  2* L2L+1.D0)*RMEL
         RMEL =  DSQRT(  2* L  +1.D0)*RMEL
         WIG1 =                 WIG(2*L2H,2*L,2*L2L,0,0)
          IF(WIG1 .EQ. 0.D0) GO TO 1000
C            WRITE(7,8)L2H,L,L2L,WIG1
    8    FORMAT('WIG: L2H,L,L2L=',3I3,G12.3/)
         RMEL =  (-1)**L2H*RMEL*WIG1/DSQRT(4.D0*PI)
                  GO TO 1002
 1001    RMES =  DSQRT(2.D0*S1 + 1.D0)
         RMEL =  DSQRT(  2* L2H+1.D0)
 1003     AS = 1.D0/DSQRT(4.D0*PI)
      IF(LLI .NE. LHE) AS = 0.D0
      IF(ISHE.NE.ISLI) AS = 0.D0

      RETURN
 1002     CONTINUE
C
C   ****  NUCLEON CASE : S1 = S2 = 1/2     S1+S2 = 1
C
        IF( L )211,211,212
  211   A = (-1)**(1+ ISHE+ISIG)*
     *  WRACA(.5D0 ,.5D0 ,1.D0*ISIG,1.D0*ISHE,1.D0*ISLI,.5D0    )
         A = A*RMES*RMEL
        A =   1.D0/DSQRT(2.D0*ISIG+1.D0)
     *                             /DSQRT(2.D0*L2H+1.D0) * A
         IF(JHE .EQ. 0) GO TO 213
         IF(JLI .EQ. 0) GO TO 214
          GO TO 215
C *** CASE JHE = 0
  213    IF(LLI .NE.LHE)GO TO 1000
         IF(ISHE.NE.LHE)GO TO 1000
         IF(JLI .NE. J )GO TO 1000
         A = (-1)**(JHE + ISLI +LHE+ISHE +1 + J )*A
         A = DSQRT( 2.D0*ISLI + 1.D0) * A
         AS = DSQRT( 2.D0*JLI  + 1.D0) * A
             RETURN
C *** CASE JLI = 0
  214    IF(LLI .NE.LHE)GO TO 1000
         IF(ISLI.NE.LLI)GO TO 1000
         IF(JHE .NE. J )GO TO 1000
         A = (-1)**(JHE + ISLI +LLI+ISHE +1 + J )*A
         A = DSQRT( 2.D0*ISHE + 1.D0) * A
         AS = DSQRT( 2.D0*JLI  + 1.D0) * A
             RETURN
C *** CASE JHE > 0  , JLI > 0
  215    IF(LLI .NE.LHE)GO TO 1000
         A = (-1)**(JHE + LHE +1 )*A
         A = DSQRT( 2.D0*ISHE + 1.D0) * A
         A = DSQRT( 2.D0*ISLI + 1.D0) * A
         A  = DSQRT( 2.D0*J    + 1.D0) * A
         A  = DSQRT( 2.D0*JLI  + 1.D0) * A
        AS = (-1)**(JLI+JHE+ISLI+ISHE)*
     *  WRACA(1.D0*ISHE,1.D0*ISLI,1.D0*JHE,1.D0*JLI,1.D0*J,1.D0*LLI)*A
             RETURN
C ***
C *** CASE  L  > 0  ,ISIG = 0  , J = ISIG
  212   IF(ISIG)311,311,312
  311     IF(ISLI.NE. ISHE) GO TO 1000
         A = (-1)**(L1H +L2L+ISHE + J + JLI -L )*RMES*RMEL
         A = DSQRT( 2.D0*LHE  + 1.D0) * A
         A = DSQRT( 2.D0*LLI  + 1.D0) * A
         A = DSQRT( 2.D0*JLI  + 1.D0) * A
         A = A/DSQRT( 2.D0)
        A = (-1)**(L2L+L1L+LHE+L)*
     *  WRACA(1.D0*L2L,1.D0*L1L,1.D0*L,1.D0*LHE,1.D0*LLI,1.D0*L2H) * A
        AS= (-1)**(LLI+LHE+JHE+JLI)*
     *  WRACA(1.D0*JHE,1.D0*JLI,1.D0*LHE,1.D0*LLI,1.D0*J,1.D0*ISHE)* A
             RETURN
C ***
C *** CASE  L  > 0  ,ISIG > 0
  312    A = (-1)**(L1H +L2L -LHE + 1 +ISLI -L - ISIG)*RMES*RMEL
         A = DSQRT( 2.D0*LHE  + 1.D0) * A
         A = DSQRT( 2.D0*LLI  + 1.D0) * A
         A = DSQRT( 2.D0*ISHE + 1.D0) * A
         A = DSQRT( 2.D0*ISLI + 1.D0) * A
         A = DSQRT( 2.D0*J    + 1.D0) * A
         A = DSQRT( 2.D0*JLI  + 1.D0) * A
C    ***  WIG,RAKAH,9-J
C     A = (-1)**(-JLI+J-MJHE)*DSQRT(2.D0*JHE + 1.D0) * A
C      A = WIG(2*JLI,2*J,2*JHE,2*MJLI,2*MJ ) * A
        A = (-1)**(L2L+L1L+LHE+L)*
     *  WRACA(1.D0*L2L,1.D0*L1L,1.D0*L,1.D0*LHE,1.D0*LLI,1.D0*L2H) * A
        A = (-1)**(1+ ISHE+ISIG)*
     *  WRACA(.5D0 ,.5D0 ,1.D0*ISIG,1.D0*ISHE,1.D0*ISLI,.5D0    ) * A
C
C   CHECK ON JF > 0
C
        IF(JHE) 11, 11, 12
   11     IF(LHE .NE. ISHE) GO TO 1000
          IF(JLI .NE. J   ) GO TO 1000
        A = (-1)**(L +LHE+ISLI+JLI)/DSQRT(2.D0*JLI+1.D0)
     *                             /DSQRT(2.D0*LHE+1.D0) * A
        AS = (-1)**(LLI+L +ISLI+ISIG)*
     *  WRACA(1.D0*LLI,1.D0*L,1.D0*ISLI,1.D0*ISIG,1.D0*LHE ,1.D0*JLI)*A
              GO TO 13
C *** CASE JHE > 0
C
  12    IF(JLI)111,111,112
  111     IF(LLI .NE. ISLI) GO TO 1000
          IF(JHE .NE. J   ) GO TO 1000
        A = (-1)**(J +LHE+ISIG+LLI)/DSQRT(2.D0*J  +1.D0)
     *                             /DSQRT(2.D0*LLI+1.D0) * A
        AS = (-1)**(LHE+L +ISHE+ISIG)*
     *  WRACA(1.D0*LHE,1.D0*L,1.D0*ISHE,1.D0*ISIG,1.D0*LLI ,1.D0*J  )*A
              GO TO 13
C *** CASE JHE > 0 , JLI > 0
C
  112      B1 = DFLOAT(LHE)
           B2 = DFLOAT(LLI)
           B3 = DFLOAT(L)
           B4 = DFLOAT(ISHE)
           B5 = DFLOAT(ISLI)
           B6 = DFLOAT(ISIG)
           B7 = DFLOAT(JHE)
           B8 = DFLOAT(JLI)
           B9 = DFLOAT(J)
        AS= SIM9J(B1,B2,B3,B4,B5,B6,B7,B8,B9) * A
   13        RETURN
 1000     AS = 0.D0
             RETURN
                END
  
