c
c   F. Nunes & I. Thompson, 1st May 1995
c   Calculation of the momentum distribution
c   for the hyperspherical basis, assuming the
c   hyper radial part is normalized  Integral(Xsi^2 dr)= e.g. 1
c
	Subroutine Moment(vecnm,NMAX,IMAX2,IMAX3,XJ,WJ,PJ,WL,XL,rmax,
     X	   MNM,MJAC,MLAG,MAXL,MLT,MCH,ML ,MKMAX,NPMAX,
     X	   NJAC,NLAG,AC,AN,RR,RCORE,RN,CHIP,
     X	   KK3,LLTOT3,SSTOT3,LL13,LL23,II3,JNN3)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	REAL*8 LAGNORM
c	REAL*4 RCORE
      DIMENSION XJ(MJAC),WJ(MJAC),  XL(MLAG),WL(MLAG)
      DIMENSION PJ(0:MNM,0:MAXL,-MLT:MLT,MJAC)
      INTEGER KK3(IMAX3),LL13(MCH),LL23(MCH),LLTOT3(MCH),SSTOT3(MCH),
     &	      JNN3(MCH),II3(MCH)
      DIMENSION VECNM(ML)
	parameter (mrbess=2000)
	real*8 BESSJ(mrbess,MKMAX+2)
	real*8 tj(MJAC),FC(MKMAX+20),GC(1),FCD(1),GCD(1)
	real*8 prob(MCH),CHI(MCH),CHIPxy(MCH)
	real*8 CHIP(MCH,NPMAX),Proby(NPMAX),Proby1(NPMAX)
	logical l1,l2,l3,l4
	hc=197.32
	kmax=0
	kmin=10000
	do it=1,IMAX3
	  kmax = max(kmax,KK3(it))
	  kmin = min(kmin,KK3(it))
	enddo
	print*
	print*,'  Momentum Distributions: '
c--------------------------------------------
c	definition of the momentum space grid
c--------------------------------------------
	numr = NPMAX
	rmaxx = rmax*1.5
	step = rmaxx/numr
	np=NPMAX
	pmax=2.0d0
	pstep=pmax/np
	print*,'  np,pmax,pstep:',np,real(pmax),real(pstep)
	print*,'  nr,rmax,rstep:',numr,real(rmaxx),real(step)
c--------------------------------------------
c      definition of the bessel function grid
c--------------------------------------------
	drbess=0.1
	nrbess=rmax*pmax/drbess
	print*,'  nrbess,drbess:',nrbess,real(drbess)
	print*,'  Using channels ',IMAX2+1,' to',IMAX2+IMAX3
c--------------------------------------------
c	Stop conditions
c--------------------------------------------
	if (nrbess.gt.mrbess) then
	   print*,'    Momentum Dist. parameters: mrbess should be',
     x				nrbess,' at least'
	   nrbess = mrbess
	   drbess = (rmax*pmax)/nrbess
	endif
c	print*,'kmin,kmax:',kmin,kmax,', RR =',real(RR)
c---------------------------------------------
c     Storing the cylindrical bessel functions
c---------------------------------------------
       do 39 k=kmin,kmax
39     BESSJ(1  ,K+1) = 0.d0
       do 40 ibess=2,nrbess
        rbess = (ibess-1)*drbess
        call COULFG(rbess,0.d0,0.d0,kmax+2.d0,FC,GC,FCD,GCD,
     &              3,2,IFAIL,m1)
        do 40 k=kmin,kmax
C       BESSJ(ibess,k+1) contains J_{K+2} (rho . k) * sqrt(rho.k)
        BESSJ(ibess,k+1) = FC(M1 + k+2 ) * sqrt(rbess)
40     continue
	
c---------------------------------------------	
C   Fourier transform of hyperspherical wave fntn:
c---------------------------------------------
	crbess = 1.d0/drbess
	DO 45 it=1,IMAX3
	prob(it)=0.d0
	DO 45 ip=1,np
45      CHIP(it,ip) = 0.d0

	rho2 = 0.0
	probt = 0
	DO 49 ir=1,numr
	r=ir*step
	U=r/RR
	S=U**2.5d0 * exp(-U*0.5d0) / sqrt(RR)
	  do 46 it=1,IMAX3
46	  CHI(it) = 0.0
	  do 47 N=0,NMAX
		RL=POLAG(N,5.D0,U)*LAGNORM(N,5.D0) * S
	  do 47 it=1,IMAX3
  	   I = it + IMAX2
	   II=(NMAX+1)*(I-1)+N+1
47	  CHI(it) = CHI(it) + RL*vecnm(II)
         write(17,51) r,(CHI(I),I=1,min(14,IMAX3))
	DO 48 it=1,IMAX3
	  z = CHI(it)**2 * step
	  prob(it)=prob(it)+z
	  rho2    =rho2    +z * r*r
	  probt   =probt   +z
	k=KK3(it)
	z = step * (-1)**((k-kmin)/2) * CHI(it)
	DO 48 ip=1,np
	p=ip*pstep
	BS=FF(r*p,crbess,BESSJ(1,k+1),nrbess)
	CHIP(it,ip)=CHIP(it,ip) + BS*z
48      continue
49      continue

	
	rho2 =  rho2/(probt+1e-20)
	rmat = sqrt((AC*RCORE**2 + 2*AN*RN*RN + rho2)/(AC+2.*AN))
	write(6,52) sqrt(rho2),RCORE,rmat
c	write(10,52) sqrt(rho2),RCORE,rmat
52	format(/' Rms <rho> =',f7.3,' fm. Using Rcore =',F7.3,' fm,',
     x          ' rms Matter radius =',F7.3,' fm.')
c	write(6,*) ' From total probabilities',real(probt)
c	write(10,*) ' From total probabilities',real(probt)
c	write(10,*) (real(prob(it)),it=1,IMAX3)

	if(.false.) then
c---------------------------------------------
c   Print out momentum wave functions CHIP
c---------------------------------------------
	do 50 ip=1,np
	 p = ip*pstep
         write(19,51) p,(CHIP(I,ip),I=1,min(14,IMAX3))
50      continue
	write(19,*) '&'
	call flush(19)
51	format(f6.2,14f8.4)

c---------------------------------------------
c   Check normalization of CHIP
c---------------------------------------------
	sump=0.d0
	do it=1,IMAX3
	prob(it)=0.d0
	do ip=1,np
	  prob(it)=prob(it)+CHIP(it,ip)**2*pstep
	enddo
	sump=sump+prob(it)
	enddo
	print*,' Norm p : ',sump
	print 71,(prob(it)/sump,it=1,IMAX3)
	print*

	sumr=0.d0
	do it=1,IMAX3
	sumr=sumr+prob(it)
	enddo
	print*,'   Norm r : ',sumr
	print 71,(prob(it)/sumr,it=1,IMAX3)

c	OPEN(UNIT=202,FILE='CHIP',STATUS='UNKNOWN',ACCESS=
c     &  'SEQUENTIAL',FORM='FORMATTED',IOSTAT=IERR)
c	do ip=1,np
c	  p=pstep*ip
c	  write(202,*) p, CHIP(1,ip),CHIP(3,ip)
c	enddo
c	close(202)
c	OPEN(UNIT=204,FILE='CHI',STATUS='UNKNOWN',ACCESS=
c     &  'SEQUENTIAL',FORM='FORMATTED',IOSTAT=IERR)
c	do ir=1,numr
c	  r=step*ir
c	  write(204,*) r, CHI(1,ir),CHI(3,ir)
c	enddo
c	close(204)
	endif
	print*
c---------------------------------------------
c   Probability Distribution on a (px,py) grid 
c---------------------------------------------
	sq8=sqrt(8.d0)
	do j=1,njac
	   tj(j)=0.5d0*acos(xj(j))
	enddo
c---------------------------------------------
c   Check normalization of PJ
c---------------------------------------------
c	do it=1,IMAX3
c          	LL1=LL13(it)
c           	LL2=LL23(it)
c           	NN = mod(LL1+LL2,2)
c           	LD=(LL1-LL2+NN)/2
c           	N=(KK3(it)-LL1-LL2)/2
c	  sumpj=0.d0
c	  do j=1,njac
c	    sumpj=sumpj+wj(j)*pj(N,LL1,LD,j)**2
c	  enddo
c	print*,' Norm PJ:  ',it,sumpj
c	enddo

	npx=np
	npy=np
	Pnorm=0.d0
	Pnormy=0.d0
	do 61 ipy=1,npy
	py=ipy*pstep
	  Proby(ipy)=0.d0
	do 60 ipx=1,npx
	px=ipx*pstep
	  Probxy=0.d0
	  pp=sqrt(px*px+py*py)
	  pp5=1.d0/pp**5
	  jpp=pp/pstep
	  if (jpp.ge.np) goto 60
	  thet=atan(px/py)
	  jthet=1
	  do j=1,njac-1
	   if (thet.ge.tj(j)) jthet=j
	  enddo
	  dthetx=(thet-tj(jthet))/(tj(jthet+1)-tj(jthet))
	  dthety=1.d0-dthetx
	  dppx=(pp-jpp*pstep)/pstep
	  dppy=1.d0-dppx
	  l1=jthet.ne.0
	  l2=jthet.ne.njac
	  l3=jpp.ne.0
	  l4=jpp.ne.np
	  do it=1,IMAX3
           	LL1=LL13(it)
           	LL2=LL23(it)
           	NN = mod(LL1+LL2,2)
           	LD=(LL1-LL2+NN)/2
           	N=(KK3(it)-LL1-LL2)/2
	    at1=0.d0
	    at2=0.d0
	    at3=0.d0
	    at4=0.d0
	    if(l1.and.l3) at1=dthety*CHIP(it,jpp)*PJ(N,LL1,LD,jthet) 
	    if(l2.and.l3) at2=dthetx*CHIP(it,jpp)*PJ(N,LL1,LD,jthet+1)
	    if(l1.and.l4) at3=dthety*CHIP(it,jpp+1)*PJ(N,LL1,LD,jthet)
	    if(l2.and.l4) at4=dthetx*CHIP(it,jpp+1)*PJ(N,LL1,LD,jthet+1)
	    CHIPxy(it)=(dppy*(at1+at2)+dppx*(at3+at4))*sq8
	  enddo
	  do 62 ich1=1,IMAX3
	  do 63 ich2=1,IMAX3
	    if (LLTOT3(ich1).ne.LLTOT3(ich2).or.
     &          SSTOT3(ich1).ne.SSTOT3(ich2).or. 
     &          LL13(ich1).ne.LL13(ich2).or. 
     &          LL23(ich1).ne.LL23(ich2).or. 
     &          II3(ich1).ne.II3(ich2).or. 
     &          JNN3(ich1).ne.JNN3(ich2)) goto 63
	    Probxy=Probxy+
     &      CHIPxy(ich1)*CHIPxy(ich2)*pp5
63        continue
62        continue
c   Check normalization of Probxy(px,py)
	  Pnorm=Pnorm+Probxy*px*px*py*py
c---------------------------------------------
c   Folding in px to obtain Proby(py)
	  Proby(ipy)=Proby(ipy)+Probxy*px*px

60      continue
c---------------------------------------------
c   Folding in px to obtain Proby(py)
c   Check normalization of Proby(py)
c---------------------------------------------
	  Proby(ipy)=Proby(ipy)*pstep
	  Pnormy=Pnormy+Proby(ipy)*py*py
61      continue
64      format(3I5,5F10.5)
65      format('------',2I5,4F10.5)
66      format(4I5,3F15.8)
c---------------------------------------------
c   Check normalizations of Probxy(px,py) & Proby(py)
c---------------------------------------------
	Pnorm=Pnorm*pstep*pstep
	Pnormy=Pnormy*pstep
	print*,'  Norm of Prob(px,py) : ',real(Pnorm),
     X         ',  Norm of Proby(py) : ',real(Pnormy)
c---------------------------------------------
c   Double projection integral 
c---------------------------------------------
	Amass=sqrt((AN+AN)*AC/(AN+AN+AC))
	iwhm = 0
	zmax=pmax
	zstep=pstep
	nz=npy-5
	do 72 iz=1,nz
	z=zstep*(iz-1) 
	zr1=z*Amass
	zr=zr1*hc
	Proby1(iz)=0.d0
	g = 2d0/3d0
	do 73 ipy=iz-1,npy
	   gg = g
	   if(ipy.eq.iz-1) gg = 1d0/3d0
	  if(ipy.gt.0)
     x	  Proby1(iz)=Proby1(iz)+ipy*Proby(ipy)*gg
	   g = 2d0 - g
73      continue
	Proby1(iz)=Proby1(iz)*zstep*zstep/(2.d0)
	if (iz.eq.1) Proby1max=Proby1(iz)
	write(44,*) real(zr),Proby1(iz)/Proby1max,Proby1(iz)
	if (Proby1(iz).lt.Proby1max*0.5.and.iwhm.eq.0) iwhm=iz
c  Spherical Mometum Distribution in pR, to be compared with CSF
	write(45,*) real(zr1),real(Proby(iz)*z*z/Amass)
72      continue
	if(iwhm.ne.0) then
	hmax = Proby1max*0.5
	zrstep = zstep*Amass*hc
	slope = (Proby1(iwhm)-Proby1(iwhm-1))/zrstep
	whmax = (iwhm-1)*zrstep - (Proby1(iwhm)-hmax)/slope
	write(6,80) whmax
80	format('  Width of half max. =',f8.2,' MeV/c'/)
	endif
	write(44,*) '&'
	write(45,*) '&'
70      continue
71      format('Prob: ',7F10.5)
	return
	end
      FUNCTION FF(Y,HI,F,N)
      DOUBLE PRECISION F(N),P,Y,HI,P1,P2,Q,X,FF
      DATA X/.16666666666667D0/
      P=Y*HI
      I=P
      IF(I.LE.0) GO TO 2
      IF(I.GE.N-2) GO TO 4
    1 P=P-I
      P1=P-1.
      P2=P-2.
      Q=P+1.
      FF=(-P2*F(I)+Q*F(I+3))*P*P1*X+(P1*F(I+1)-P*F(I+2))*Q*P2*.5
      RETURN
    2 IF(I.LT.0) GO TO 3
      I=1
      GO TO 1
    3 FF=F(1)
      RETURN
    4 IF(I.GT.N-2) GO TO 5
      I=N-3
      GO TO 1
    5 FF=F(N)
      RETURN
      END
