      SUBROUTINE F02AGF(A,IA,N,RR,RI,VR,IVR,VI,IVI,INTGER,IFAIL)
C     MARK 13 RE-ISSUE. NAG COPYRIGHT 1988.
C     MARK 14A REVISED. IER-685 (DEC 1989).
C
C     EIGENVALUES AND EIGENVECTORS OF REAL UNSYMMETRIC MATRIX
C     1ST AUGUST 1971
C
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='F02AGF')
C     .. Scalar Arguments ..
      INTEGER           IA, IFAIL, IVI, IVR, N
C     .. Array Arguments ..
      DOUBLE PRECISION  A(IA,N), RI(N), RR(N), VI(IVI,N), VR(IVR,N)
      INTEGER           INTGER(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  C, D, MACHEP, MAX, SUM, TERM
      INTEGER           I, IB, ISAVE, J, K, L
C     .. Local Arrays ..
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      DOUBLE PRECISION  X02AJF
      INTEGER           P01ABF, X02BHF
      EXTERNAL          X02AJF, P01ABF, X02BHF
C     .. External Subroutines ..
      EXTERNAL          F01AKF, F01APF, F01ATF, F01AUF, F02AQF
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, SQRT
C     .. Executable Statements ..
      ISAVE = IFAIL
      IFAIL = 1
      MACHEP = X02AJF()
      IB = X02BHF()
      CALL F01ATF(N,IB,A,IA,K,L,RR)
      CALL F01AKF(N,K,L,A,IA,INTGER)
      CALL F01APF(N,K,L,INTGER,A,IA,VR,IVR)
      CALL F01AUF(N,K,L,N,RR,VR,IVR)
      CALL F02AQF(N,1,N,MACHEP,A,IA,VR,IVR,RR,RI,INTGER,IFAIL)
      IF (IFAIL.EQ.0) GO TO 20
      IFAIL = P01ABF(ISAVE,IFAIL,SRNAME,0,P01REC)
      RETURN
   20 DO 140 I = 1, N
         IF (RI(I).EQ.0.0D0) GO TO 60
         IF (RI(I).GT.0.0D0) GO TO 100
         DO 40 J = 1, N
            VR(J,I) = VR(J,I-1)
            VI(J,I) = -VI(J,I-1)
   40    CONTINUE
         GO TO 140
   60    DO 80 J = 1, N
            VI(J,I) = 0.0D0
   80    CONTINUE
         GO TO 140
  100    DO 120 J = 1, N
            VI(J,I) = VR(J,I+1)
  120    CONTINUE
  140 CONTINUE
      DO 280 I = 1, N
         SUM = 0.0D0
         MAX = 0.0D0
         DO 180 J = 1, N
            IF (ABS(VR(J,I)).LE.MAX) GO TO 160
            MAX = ABS(VR(J,I))
  160       IF (ABS(VI(J,I)).LE.MAX) GO TO 180
            MAX = ABS(VI(J,I))
  180    CONTINUE
         DO 200 J = 1, N
            VR(J,I) = VR(J,I)/MAX
            VI(J,I) = VI(J,I)/MAX
  200    CONTINUE
         MAX = 0.0D0
         DO 240 J = 1, N
            TERM = VR(J,I)**2 + VI(J,I)**2
            SUM = SUM + TERM
            IF (TERM.LE.MAX) GO TO 220
            MAX = TERM
            C = VR(J,I)
            D = -VI(J,I)
  220       CONTINUE
  240    CONTINUE
         SUM = SUM*(C**2+D**2)
         SUM = SQRT(SUM)
         DO 260 J = 1, N
            TERM = VR(J,I)
            VR(J,I) = (VR(J,I)*C-VI(J,I)*D)/SUM
            VI(J,I) = (D*TERM+C*VI(J,I))/SUM
  260    CONTINUE
  280 CONTINUE
      RETURN
      END
      SUBROUTINE F01AKF(N,K,L,A,IA,INTGER)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 4 REVISED.
C     MARK 4.5 REVISED
C     MARK 8 REVISED. IER-248 (JUN 1980).
C     MARK 11 REVISED. VECTORISATION (JAN 1984).
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     MARK 12 REVISED. EXTENDED BLAS (JUNE 1986)
C
C     DIRHES
C     AUGUST 1ST, 1971 .
C     GIVEN THE UNSYMMETRIC MATRIX, A, STORED IN THE ARRAY A(N,N),
C     THIS SUBROUTINE REDUCES THE SUB-MATRIX OF ORDER L - K + 1,
C     WHICH STARTS AT THE ELEMENT A(K,K) AND FINISHES AT THE
C     ELEMENT A(L,L), TO HESSENBERG FORM, H, BY THE DIRECT
C     METHOD(AN = NH). THE MATRIX H IS OVERWRITTEN ON A WITH
C     DETAILS OF THE TRANSFORMATIONS (N) STORED IN THE REMAINING
C     TRIANGLE UNDER H AND IN ELEMENTS K TO L OF THE ARRAY
C     INTGER(N).
C     1ST AUGUST 1971
C
C     .. Scalar Arguments ..
      INTEGER           IA, K, L, N
C     .. Array Arguments ..
      DOUBLE PRECISION  A(IA,N)
      INTEGER           INTGER(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  X, Y
      INTEGER           I, J, K1, M
C     .. External Subroutines ..
      EXTERNAL          DGEMV, DTRSV
C     .. Intrinsic Functions ..
      INTRINSIC         ABS
C     .. Executable Statements ..
      K1 = K + 1
      IF (K1.GT.L) RETURN
      DO 140 J = K1, N
         M = J
         X = 0.0D0
         IF (J.GT.L) GO TO 120
         DO 20 I = J, L
            IF (ABS(A(I,J-1)).LE.ABS(X)) GO TO 20
            X = A(I,J-1)
            M = I
   20    CONTINUE
         INTGER(J) = M
         IF (M.EQ.J) GO TO 80
C        INTERCHANGE ROWS AND COLUMNS OF A.
         DO 40 I = K, N
            Y = A(M,I)
            A(M,I) = A(J,I)
            A(J,I) = Y
   40    CONTINUE
         DO 60 I = 1, L
            Y = A(I,M)
            A(I,M) = A(I,J)
            A(I,J) = Y
   60    CONTINUE
   80    IF (X.NE.0.0D0 .AND. J.LT.L) THEN
            DO 100 I = J + 1, L
               A(I,J-1) = A(I,J-1)/X
  100       CONTINUE
            CALL DGEMV('N',L,L-J,1.0D0,A(1,J+1),IA,A(J+1,J-1),1,1.0D0,
     *                 A(1,J),1)
         END IF
  120    CALL DTRSV('L','N','U',J-K,A(K+1,K),IA,A(K+1,J),1)
         IF (J.LT.L) CALL DGEMV('N',L-J,J-K,-1.0D0,A(J+1,K),IA,A(K+1,J),
     *                          1,1.0D0,A(J+1,J),1)
  140 CONTINUE
      RETURN
      END
      SUBROUTINE F01APF(N,LOW,IUPP,INTGER,H,IH,V,IV)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 4 REVISED.
C     MARK 4.5 REVISED
C     MARK 5C REVISED
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     DIRTRANS
C     FORM THE MATRIX OF ACCUMULATED TRANSFORMATIONS IN THE ARRAY
C     V(N,N) FROM THE INFORMATION LEFT BY SUBROUTINE F01AKF
C     BELOW THE UPPER HESSENBERG MATRIX, H, IN THE ARRAY H(N,N)
C     AND IN THE INTEGER ARRAY INTGER(N).
C     1ST AUGUST 1971
C
C     .. Scalar Arguments ..
      INTEGER           IH, IUPP, IV, LOW, N
C     .. Array Arguments ..
      DOUBLE PRECISION  H(IH,N), V(IV,N)
      INTEGER           INTGER(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  X
      INTEGER           I, I1, II, J, LOW1, M
C     .. Executable Statements ..
      DO 40 I = 1, N
         DO 20 J = 1, N
            V(I,J) = 0.0D0
   20    CONTINUE
         V(I,I) = 1.0D0
   40 CONTINUE
      LOW1 = LOW + 1
      IF (LOW1.GT.IUPP) RETURN
      DO 120 II = LOW1, IUPP
         I = LOW1 + IUPP - II
         I1 = I - 1
         IF (LOW1.GT.I1) GO TO 80
         DO 60 J = LOW1, I1
            V(I,J) = H(I,J-1)
   60    CONTINUE
   80    M = INTGER(I)
         IF (M.EQ.I) GO TO 120
         DO 100 J = LOW1, IUPP
            X = V(M,J)
            V(M,J) = V(I,J)
            V(I,J) = X
  100    CONTINUE
  120 CONTINUE
      RETURN
      END
      SUBROUTINE F01ATF(N,IB,A,IA,LOW,LHI,D)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 4 REVISED.
C     MARK 4.5 REVISED
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     BALANCE
C     REDUCE THE NORM OF A(N,N) BY EXACT DIAGONAL SIMILARITY
C     TRANSFORMATIONS STORED IN D(N).
C     DECEMBER 1ST.,1971
C
C     .. Scalar Arguments ..
      INTEGER           IA, IB, LHI, LOW, N
C     .. Array Arguments ..
      DOUBLE PRECISION  A(IA,N), D(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  B2, C, F, G, R, S
      INTEGER           I, J, JJ, K, L
      LOGICAL           NOCONV
C     .. External Subroutines ..
      EXTERNAL          F01ATZ
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, DBLE
C     .. Executable Statements ..
      B2 = IB*IB
      L = 1
      K = N
   20 IF (K.LT.1) GO TO 100
C     SEARCH FOR ROWS ISOLATING AN EIGENVALUE AND PUSH THEM DOWN
      J = K + 1
      DO 60 JJ = 1, K
         J = J - 1
         R = 0.0D0
         DO 40 I = 1, K
            IF (I.EQ.J) GO TO 40
            R = R + ABS(A(J,I))
   40    CONTINUE
         IF (R.EQ.0.0D0) GO TO 80
   60 CONTINUE
      GO TO 100
   80 CALL F01ATZ(K,A,IA,D,K,L,N,J)
      K = K - 1
      GO TO 20
C     SEARCH FOR COLUMNS ISOLATING AN EIGENVALUE AND PUSH THEM
C     LEFT.
  100 IF (L.GT.K) GO TO 180
      DO 140 J = L, K
         C = 0.0D0
         DO 120 I = L, K
            IF (I.EQ.J) GO TO 120
            C = C + ABS(A(I,J))
  120    CONTINUE
         IF (C.EQ.0.0D0) GO TO 160
  140 CONTINUE
      GO TO 180
  160 CALL F01ATZ(L,A,IA,D,K,L,N,J)
      L = L + 1
      GO TO 100
C     NOW BALANCE THE SUBMATRIX IN ROWS L THROUGH K.
  180 LOW = L
      LHI = K
      IF (L.GT.K) GO TO 220
      DO 200 I = L, K
         D(I) = 1.0D0
  200 CONTINUE
  220 NOCONV = .FALSE.
      IF (L.GT.K) GO TO 420
      DO 400 I = L, K
         C = 0.0D0
         R = 0.0D0
         DO 240 J = L, K
            IF (J.EQ.I) GO TO 240
            C = C + ABS(A(J,I))
            R = R + ABS(A(I,J))
  240    CONTINUE
         G = R/DBLE(IB)
         F = 1.0D0
         S = C + R
  260    IF (C.GE.G) GO TO 280
         F = F*DBLE(IB)
         C = C*B2
         GO TO 260
  280    G = R*DBLE(IB)
  300    IF (C.LT.G) GO TO 320
         F = F/DBLE(IB)
         C = C/B2
         GO TO 300
  320    IF (((C+R)/F).GE.(0.95D0*S)) GO TO 400
         G = 1.0D0/F
         D(I) = D(I)*F
         NOCONV = .TRUE.
         IF (L.GT.N) GO TO 360
         DO 340 J = L, N
            A(I,J) = A(I,J)*G
  340    CONTINUE
  360    DO 380 J = 1, K
            A(J,I) = A(J,I)*F
  380    CONTINUE
  400 CONTINUE
  420 IF (NOCONV) GO TO 220
      RETURN
      END
      SUBROUTINE F01AUF(N,LOW,LHI,M,D,Z,IZ)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 4 REVISED.
C     MARK 4.5 REVISED
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     BALBAK
C     BACKWARD TRANSFORMATION OF A SET OF RIGHT-HAND EIGENVECTORS
C     OF A BALANCED MATRIX INTO THE EIGENVECTORS OF THE ORIGINAL
C     MATRIX FROM WHICH THE BALANCED MATRIX WAS DERIVED BY A CALL
C     OF SUBROUTINE F01ATF.
C     DECEMBER 1ST.,1971
C
C     .. Scalar Arguments ..
      INTEGER           IZ, LHI, LOW, M, N
C     .. Array Arguments ..
      DOUBLE PRECISION  D(N), Z(IZ,M)
C     .. Local Scalars ..
      DOUBLE PRECISION  S
      INTEGER           I, II, J, K, LHI1, LOW1
C     .. Executable Statements ..
      IF (LOW.GT.LHI) GO TO 60
      DO 40 I = LOW, LHI
         S = D(I)
C        LEFT-HAND EIGENVECTORS ARE BACK TRANSFORMED IF THE
C        FOREGOING STATEMENT IS REPLACED BY S=1/D(I)
         DO 20 J = 1, M
            Z(I,J) = Z(I,J)*S
   20    CONTINUE
   40 CONTINUE
   60 I = LOW
      LOW1 = LOW - 1
      IF (LOW1.LT.1) GO TO 120
      DO 100 II = 1, LOW1
         I = I - 1
         K = D(I)
         IF (K.EQ.I) GO TO 100
         DO 80 J = 1, M
            S = Z(I,J)
            Z(I,J) = Z(K,J)
            Z(K,J) = S
   80    CONTINUE
  100 CONTINUE
  120 LHI1 = LHI + 1
      IF (LHI1.GT.N) RETURN
      DO 160 I = LHI1, N
         K = D(I)
         IF (K.EQ.I) GO TO 160
         DO 140 J = 1, M
            S = Z(I,J)
            Z(I,J) = Z(K,J)
            Z(K,J) = S
  140    CONTINUE
  160 CONTINUE
      RETURN
      END
      SUBROUTINE F02AQF(N,LOW,UPP,MACHEP,H,IH,VECS,IVECS,WR,WI,CNT,
     *                  IFAIL)
C     MARK 13 RE-ISSUE. NAG COPYRIGHT 1988.
C
C     HQR2
C     FINDS THE EIGENVALUES AND EIGENVECTORS OF A REAL MATRIX
C     WHICH HAS BEEN REDUCED TO UPPER HESSENBERG FORM IN THE ARRAY
C     H(N,N) WITH THE ACCUMULATED TRANSFORMATIONS STORED IN
C     THE ARRAY VECS(N,N). THE REAL AND IMAGINARY PARTS OF THE
C     EIGENVALUES ARE FORMED IN THE ARRAYS WR, WI(N) AND THE
C     EIGENVECTORS ARE FORMED IN THE ARRAY VECS(N,N) WHERE
C     ONLY ONE COMPLEX VECTOR, CORRESPONDING TO THE ROOT WITH
C     POSITIVE IMAGINARY PART, IS FORMED FOR A COMPLEX PAIR. LOW
C     AND UPP ARE TWO INTEGERS PRODUCED IN BALANCING WHERE
C     EIGENVALUES ARE ISOLATED IN POSITIONS 1 TO LOW-1 AND UPP+1
C     TO N. IF BALANCING IS NOT USED LOW=1, UPP=N. MACHEP IS THE
C     RELATIVE MACHINE PRECISION. THE SUBROUTINE WILL FAIL IF
C     ALL EIGENVALUES TAKE MORE THAN 30*N ITERATIONS.
C     1ST DECEMBER 1971
C
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='F02AQF')
C     .. Scalar Arguments ..
      DOUBLE PRECISION  MACHEP
      INTEGER           IFAIL, IH, IVECS, LOW, N, UPP
C     .. Array Arguments ..
      DOUBLE PRECISION  H(IH,N), VECS(IVECS,N), WI(N), WR(N)
      INTEGER           CNT(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  NORM, P, Q, R, RA, S, SA, T, U, VI, VR, W, X, Y,
     *                  Z
      INTEGER           EN, EN2, I, I1, II, ISAVE, ITN, ITS, J, JJ, K,
     *                  KK, L, LL, LOW1, M, M2, M3, MM, NA, NA1, NHS,
     *                  UPP1
      LOGICAL           NOTLAS
C     .. Local Arrays ..
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      DOUBLE PRECISION  A02ABF, X02AJF, X02AKF
      INTEGER           P01ABF
      EXTERNAL          A02ABF, X02AJF, X02AKF, P01ABF
C     .. External Subroutines ..
      EXTERNAL          A02ACF, DGEMV
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, MIN, DBLE, SQRT
C     .. Executable Statements ..
      ISAVE = IFAIL
C     COMPUTE MATRIX NORM
      NORM = 0.0D0
      K = 1
      DO 40 I = 1, N
         DO 20 J = K, N
            NORM = NORM + ABS(H(I,J))
   20    CONTINUE
         K = I
   40 CONTINUE
      NHS = N*(N+1)/2 + N - 1
C     ISOLATED ROOTS
      IF (LOW.LE.1) GO TO 80
      J = LOW - 1
      DO 60 I = 1, J
         WR(I) = H(I,I)
         WI(I) = 0.0D0
         CNT(I) = 0
   60 CONTINUE
   80 IF (UPP.GE.N) GO TO 120
      J = UPP + 1
      DO 100 I = J, N
         WR(I) = H(I,I)
         WI(I) = 0.0D0
         CNT(I) = 0
  100 CONTINUE
  120 EN = UPP
      T = 0.0D0
      ITN = 30*N
  140 IF (EN.LT.LOW) GO TO 880
      ITS = 0
      NA = EN - 1
C     LOOK FOR SINGLE SMALL SUB-DIAGONAL ELEMENT
  160 IF (LOW+1.GT.EN) GO TO 200
      LOW1 = LOW + 1
      DO 180 LL = LOW1, EN
         L = EN + LOW1 - LL
         S = ABS(H(L-1,L-1)) + ABS(H(L,L))
         IF (S.LT.X02AKF()/X02AJF()) S = NORM/DBLE(NHS)
         IF (ABS(H(L,L-1)).LE.MACHEP*S) GO TO 220
  180 CONTINUE
  200 L = LOW
  220 X = H(EN,EN)
      IF (L.EQ.EN) GO TO 740
      Y = H(NA,NA)
      W = H(EN,NA)*H(NA,EN)
      IF (L.EQ.NA) GO TO 760
      IF (ITN.LE.0) GO TO 1500
C     FORM SHIFT
      IF ((ITS.NE.10) .AND. (ITS.NE.20)) GO TO 280
      T = T + X
      IF (LOW.GT.EN) GO TO 260
      DO 240 I = LOW, EN
         H(I,I) = H(I,I) - X
  240 CONTINUE
  260 S = ABS(H(EN,NA)) + ABS(H(NA,EN-2))
      X = 0.75D0*S
      Y = X
      W = -0.4375D0*S**2
  280 ITS = ITS + 1
      ITN = ITN - 1
C     LOOK FOR TWO CONSECUTIVE SMALL SUB-DIAGONAL ELEMENTS
      IF (L.GT.EN-2) GO TO 320
      EN2 = EN - 2
      DO 300 MM = L, EN2
         M = L + EN2 - MM
         Z = H(M,M)
         R = X - Z
         S = Y - Z
         P = (R*S-W)/H(M+1,M) + H(M,M+1)
         Q = H(M+1,M+1) - Z - R - S
         R = H(M+2,M+1)
         S = ABS(P) + ABS(Q) + ABS(R)
         P = P/S
         Q = Q/S
         R = R/S
         IF (M.EQ.L) GO TO 320
         IF ((ABS(H(M,M-1))*(ABS(Q)+ABS(R))).LE.(MACHEP*ABS(P)
     *       *(ABS(H(M-1,M-1))+ABS(Z)+ABS(H(M+1,M+1))))) GO TO 320
  300 CONTINUE
  320 M2 = M + 2
      IF (M2.GT.EN) GO TO 360
      DO 340 I = M2, EN
         H(I,I-2) = 0.0D0
  340 CONTINUE
  360 M3 = M + 3
      IF (M3.GT.EN) GO TO 400
      DO 380 I = M3, EN
         H(I,I-3) = 0.0D0
  380 CONTINUE
  400 IF (M.GT.NA) GO TO 720
      DO 700 K = M, NA
         NOTLAS = K .NE. NA
         IF (K.EQ.M) GO TO 420
         P = H(K,K-1)
         Q = H(K+1,K-1)
         R = 0
         IF (NOTLAS) R = H(K+2,K-1)
         X = ABS(P) + ABS(Q) + ABS(R)
         IF (X.EQ.0.0D0) GO TO 700
         P = P/X
         Q = Q/X
         R = R/X
  420    S = SQRT(P**2+Q**2+R**2)
         IF (P.LT.0.0D0) S = -S
         IF (K.NE.M) GO TO 440
         IF (L.NE.M) H(K,K-1) = -H(K,K-1)
         GO TO 460
  440    H(K,K-1) = -S*X
  460    P = P + S
         X = P/S
         Y = Q/S
         Z = R/S
         Q = Q/P
         R = R/P
C        ROW MODIFICATION
         IF (NOTLAS) GO TO 500
         DO 480 J = K, N
            P = H(K,J) + Q*H(K+1,J)
            H(K+1,J) = H(K+1,J) - P*Y
            H(K,J) = H(K,J) - P*X
  480    CONTINUE
         GO TO 540
  500    DO 520 J = K, N
            P = H(K,J) + Q*H(K+1,J) + R*H(K+2,J)
            H(K+2,J) = H(K+2,J) - P*Z
            H(K+1,J) = H(K+1,J) - P*Y
            H(K,J) = H(K,J) - P*X
  520    CONTINUE
  540    J = EN
         IF (K+3.LT.EN) J = K + 3
C        COLUMN MODIFICATION
         IF (NOTLAS) GO TO 580
         DO 560 I = 1, J
            P = X*H(I,K) + Y*H(I,K+1)
            H(I,K+1) = H(I,K+1) - P*Q
            H(I,K) = H(I,K) - P
  560    CONTINUE
         GO TO 620
  580    DO 600 I = 1, J
            P = X*H(I,K) + Y*H(I,K+1) + Z*H(I,K+2)
            H(I,K+2) = H(I,K+2) - P*R
            H(I,K+1) = H(I,K+1) - P*Q
            H(I,K) = H(I,K) - P
  600    CONTINUE
C        ACCUMULATE TRANSFORMATIONS
  620    IF (LOW.GT.UPP) GO TO 700
         IF (NOTLAS) GO TO 660
         DO 640 I = LOW, UPP
            P = X*VECS(I,K) + Y*VECS(I,K+1)
            VECS(I,K+1) = VECS(I,K+1) - P*Q
            VECS(I,K) = VECS(I,K) - P
  640    CONTINUE
         GO TO 700
  660    DO 680 I = LOW, UPP
            P = X*VECS(I,K) + Y*VECS(I,K+1) + Z*VECS(I,K+2)
            VECS(I,K+2) = VECS(I,K+2) - P*R
            VECS(I,K+1) = VECS(I,K+1) - P*Q
            VECS(I,K) = VECS(I,K) - P
  680    CONTINUE
  700 CONTINUE
  720 GO TO 160
C     ONE ROOT FOUND
  740 WR(EN) = X + T
      H(EN,EN) = WR(EN)
      WI(EN) = 0.0D0
      CNT(EN) = ITS
      EN = NA
      GO TO 140
C     TWO ROOTS FOUND
  760 P = (Y-X)/2.0D0
      Q = P**2 + W
      Z = SQRT(ABS(Q))
      X = X + T
      H(EN,EN) = X
      H(NA,NA) = Y + T
      CNT(EN) = -ITS
      CNT(NA) = ITS
      IF (Q.LT.0.0D0) GO TO 840
C     REAL PAIR
      IF (P.LT.0.0D0) Z = P - Z
      IF (P.GT.0.0D0) Z = P + Z
      WR(NA) = X + Z
      WR(EN) = WR(NA)
      IF (Z.NE.0.0D0) WR(EN) = X - W/Z
      WI(NA) = 0.0D0
      WI(EN) = 0.0D0
      X = H(EN,NA)
      R = A02ABF(X,Z)
      P = X/R
      Q = Z/R
C     ROW MODIFICATION
      DO 780 J = NA, N
         Z = H(NA,J)
         H(NA,J) = Q*Z + P*H(EN,J)
         H(EN,J) = Q*H(EN,J) - P*Z
  780 CONTINUE
C     COLUMN MODIFICATION
      DO 800 I = 1, EN
         Z = H(I,NA)
         H(I,NA) = Q*Z + P*H(I,EN)
         H(I,EN) = Q*H(I,EN) - P*Z
  800 CONTINUE
C     ACCUMULATE TRANSFORMATIONS
      DO 820 I = LOW, UPP
         Z = VECS(I,NA)
         VECS(I,NA) = Q*Z + P*VECS(I,EN)
         VECS(I,EN) = Q*VECS(I,EN) - P*Z
  820 CONTINUE
      GO TO 860
C     COMPLEX PAIR
  840 WR(NA) = X + P
      WR(EN) = X + P
      WI(NA) = Z
      WI(EN) = -Z
  860 EN = EN - 2
      GO TO 140
C     ALL ROOTS FOUND NOW BACKSUBSTITUTE
  880 IF (NORM.EQ.0.0D0) GO TO 1480
      NORM = NORM*MACHEP
C     BACKSUBSTITUTION
      DO 1340 KK = 1, N
         EN = N + 1 - KK
         P = WR(EN)
         Q = WI(EN)
         NA = EN - 1
         IF (Q.NE.0.0D0) GO TO 1120
C        REAL VECTOR
         H(EN,EN) = 1.0D0
         IF (NA.LT.1) GO TO 1340
         DO 1100 II = 1, NA
            I = NA + 1 - II
            I1 = I - 1
            W = H(I,I) - P
            R = H(I,EN)
            IF (WI(I).GE.0.0D0) GO TO 900
            Z = W
            S = R
            GO TO 1100
  900       IF (WI(I).GT.0.0D0) GO TO 1020
C           MODIFICATION TO STOP OVERFLOW
            IF (W.NE.0.0D0) GO TO 940
            IF (ABS(R).LT.10.0D0*NORM) GO TO 960
            R = -R
            DO 920 J = 1, EN
               H(J,EN) = H(J,EN)*NORM
  920       CONTINUE
            GO TO 980
  940       R = -R/W
            GO TO 980
  960       R = -R/NORM
  980       H(I,EN) = R
            IF (I1.EQ.0) GO TO 1100
            DO 1000 J = 1, I1
               H(J,EN) = H(J,EN) + H(J,I)*R
 1000       CONTINUE
            GO TO 1100
C           SOLVE REAL EQUATIONS
 1020       X = H(I,I+1)
            Y = H(I+1,I)
            Q = (WR(I)-P)**2 + WI(I)**2
            T = (X*S-Z*R)/Q
            H(I,EN) = T
            IF (ABS(X).GT.ABS(Z)) GO TO 1040
            R = (-S-Y*T)/Z
            GO TO 1060
 1040       R = (-R-W*T)/X
 1060       H(I+1,EN) = R
            IF (I1.EQ.0) GO TO 1100
            DO 1080 J = 1, I1
               H(J,EN) = (H(J,EN)+H(J,I+1)*R) + H(J,I)*T
 1080       CONTINUE
 1100    CONTINUE
C        END REAL VECTOR
         GO TO 1340
 1120    IF (Q.GT.0.0D0) GO TO 1340
C        COMPLEX VECTOR ASSOCIATED WITH LAMBDA=P-I*Q
         IF (ABS(H(EN,NA)).LE.ABS(H(NA,EN))) GO TO 1140
         R = Q/H(EN,NA)
         S = -(H(EN,EN)-P)/H(EN,NA)
         GO TO 1160
 1140    CALL A02ACF(0.0D0,-H(NA,EN),H(NA,NA)-P,Q,R,S)
 1160    H(EN,NA) = 0.0D0
         H(EN,EN) = 1.0D0
         H(NA,NA) = R
         H(NA,EN) = S
         IF (NA.LT.2) GO TO 1340
         NA1 = NA - 1
         DO 1180 J = 1, NA1
            H(J,EN) = H(J,EN) + H(J,NA)*S
            H(J,NA) = H(J,NA)*R
 1180    CONTINUE
         DO 1320 II = 1, NA1
            I = 1 + NA1 - II
            I1 = I - 1
            W = H(I,I) - P
            RA = H(I,NA)
            SA = H(I,EN)
            IF (WI(I).GE.0.0D0) GO TO 1200
            Z = W
            R = RA
            S = SA
            GO TO 1320
 1200       IF (WI(I).EQ.0.0D0) GO TO 1280
C           SOLVE COMPLEX EQUATIONS
            X = H(I,I+1)
            Y = H(I+1,I)
            VR = (WR(I)-P)**2 + WI(I)**2 - Q**2
            VI = (WR(I)-P)*2.0D0*Q
            IF ((VR.EQ.0.0D0) .AND. (VI.EQ.0.0D0))
     *          VR = MACHEP*NORM*(ABS(W)+ABS(Q)+ABS(X)+ABS(Y)+ABS(Z))
            CALL A02ACF(X*R-Z*RA+Q*SA,X*S-Z*SA-Q*RA,VR,VI,T,U)
            IF (ABS(X).LE.ABS(Z)+ABS(Q)) GO TO 1220
            R = (-RA-W*T+Q*U)/X
            S = (-SA-W*U-Q*T)/X
            GO TO 1240
 1220       CALL A02ACF(-R-Y*T,-S-Y*U,Z,Q,R,S)
 1240       H(I,NA) = T
            H(I,EN) = U
            H(I+1,NA) = R
            H(I+1,EN) = S
            IF (I1.EQ.0) GO TO 1320
            DO 1260 J = 1, I1
               H(J,NA) = (H(J,NA)+H(J,I+1)*R) + H(J,I)*T
               H(J,EN) = (H(J,EN)+H(J,I+1)*S) + H(J,I)*U
 1260       CONTINUE
            GO TO 1320
 1280       CALL A02ACF(-RA,-SA,W,Q,R,S)
            H(I,NA) = R
            H(I,EN) = S
            IF (I1.EQ.0) GO TO 1320
            DO 1300 J = 1, I1
               H(J,NA) = H(J,NA) + H(J,I)*R
               H(J,EN) = H(J,EN) + H(J,I)*S
 1300       CONTINUE
 1320    CONTINUE
C        END COMPLEX VECTOR
 1340 CONTINUE
C     END BACKSUBSTITUTION
C     VECTORS OF ISOLATED ROOTS
      LOW1 = LOW - 1
      UPP1 = UPP + 1
      DO 1420 J = 1, N
         M = MIN(J,LOW1)
         IF (M.LT.1) GO TO 1380
         DO 1360 I = 1, M
            VECS(I,J) = H(I,J)
 1360    CONTINUE
 1380    IF (UPP1.GT.J) GO TO 1420
         DO 1400 I = UPP1, J
            VECS(I,J) = H(I,J)
 1400    CONTINUE
 1420 CONTINUE
C     MULTIPLY BY TRANSFORMATION MATRIX TO GIVE
C     VECTORS OF ORIGINAL FULL MATRIX
      DO 1460 JJ = LOW, N
         J = LOW + N - JJ
         M = MIN(J,UPP)
         DO 1440 I = LOW, UPP
            VECS(I,J) = VECS(I,M)*H(M,J)
 1440    CONTINUE
         M = M - 1
         IF (M+1.GE.LOW) CALL DGEMV('N',UPP-LOW+1,M-LOW+1,1.0D0,
     *                              VECS(LOW,LOW),IVECS,H(LOW,J),1,
     *                              1.0D0,VECS(LOW,J),1)
 1460 CONTINUE
 1480 IFAIL = 0
      RETURN
 1500 IFAIL = P01ABF(ISAVE,1,SRNAME,0,P01REC)
      RETURN
      END
      SUBROUTINE F01ATZ(M,A,IA,D,K,L,N,J)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 4 REVISED.
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     NAG COPYRIGHT 1975
C     MARK 4.5 REVISED
C
C     AUXILIARY ROUTINE CALLED BY F01ATF.
C     INTERCHANGES ELEMENTS 1 TO K OF COLUMNS J AND M,
C     AND ELEMENTS L TO N OF ROWS J AND M.
C     .. Scalar Arguments ..
      INTEGER           IA, J, K, L, M, N
C     .. Array Arguments ..
      DOUBLE PRECISION  A(IA,N), D(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  F
      INTEGER           I
C     .. Executable Statements ..
      D(M) = J
      IF (J.EQ.M) GO TO 60
      DO 20 I = 1, K
         F = A(I,J)
         A(I,J) = A(I,M)
         A(I,M) = F
   20 CONTINUE
      IF (L.GT.N) GO TO 60
      DO 40 I = L, N
         F = A(J,I)
         A(J,I) = A(M,I)
         A(M,I) = F
   40 CONTINUE
   60 RETURN
      END
      SUBROUTINE F06AAZ ( SRNAME, INFO )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     .. Scalar Arguments ..
      INTEGER            INFO
      CHARACTER*13       SRNAME
C     ..
C
C  Purpose
C  =======
C
C  F06AAZ  is an error handler for the Level 2 BLAS routines.
C
C  It is called by the Level 2 BLAS routines if an input parameter is
C  invalid.
C
C  Parameters
C  ==========
C
C  SRNAME - CHARACTER*13.
C           On entry, SRNAME specifies the name of the routine which
C           called F06AAZ.
C
C  INFO   - INTEGER.
C           On entry, INFO specifies the position of the invalid
C           parameter in the parameter-list of the calling routine.
C
C
C  Auxiliary routine for Level 2 Blas.
C
C  Written on 20-July-1986.
C
C     .. Local Scalars ..
      INTEGER            IFAIL
      CHARACTER*80       REC (1)
C     .. External Functions ..
      INTEGER            P01ABF
      EXTERNAL           P01ABF
C     ..
C     .. Executable Statements ..
      WRITE (REC (1),99999) SRNAME, INFO
      IFAIL = 0
      IFAIL = P01ABF (IFAIL, -1, SRNAME(1:6), 1, REC)
C
      RETURN
C
99999 FORMAT ( ' ** On entry to ', A13, ' parameter number ', I2,
     $         ' had an illegal value' )
C
C     End of F06AAZ.
C
      END
      SUBROUTINE F06PAF( TRANS, M, N, ALPHA, A, LDA, X, INCX,
     $                   BETA, Y, INCY )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     AXP4 VERSION FOR VECTOR MACHINES
C     .. Entry Points ..
      ENTRY      DGEMV ( TRANS, M, N, ALPHA, A, LDA, X, INCX,
     $                   BETA, Y, INCY )
C     .. Scalar Arguments ..
      DOUBLE PRECISION   ALPHA, BETA
      INTEGER            INCX, INCY, LDA, M, N
      CHARACTER*1        TRANS
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), X( * ), Y( * )
C     ..
C
C  Purpose
C  =======
C
C  DGEMV  performs one of the matrix-vector operations
C
C     y := alpha*A*x + beta*y,   or   y := alpha*A'*x + beta*y,
C
C  where alpha and beta are scalars, x and y are vectors and A is an
C  m by n matrix.
C
C  Parameters
C  ==========
C
C  TRANS  - CHARACTER*1.
C           On entry, TRANS specifies the operation to be performed as
C           follows:
C
C              TRANS = 'N' or 'n'   y := alpha*A*x + beta*y.
C
C              TRANS = 'T' or 't'   y := alpha*A'*x + beta*y.
C
C              TRANS = 'C' or 'c'   y := alpha*A'*x + beta*y.
C
C           Unchanged on exit.
C
C  M      - INTEGER.
C           On entry, M specifies the number of rows of the matrix A.
C           M must be at least zero.
C           Unchanged on exit.
C
C  N      - INTEGER.
C           On entry, N specifies the number of columns of the matrix A.
C           N must be at least zero.
C           Unchanged on exit.
C
C  ALPHA  - DOUBLE PRECISION.
C           On entry, ALPHA specifies the scalar alpha.
C           Unchanged on exit.
C
C  A      - DOUBLE PRECISION array of DIMENSION ( LDA, n ).
C           Before entry, the leading m by n part of the array A must
C           contain the matrix of coefficients.
C           Unchanged on exit.
C
C  LDA    - INTEGER.
C           On entry, LDA specifies the first dimension of A as declared
C           in the calling (sub) program. LDA must be at least
C           max( 1, m ).
C           Unchanged on exit.
C
C  X      - DOUBLE PRECISION array of DIMENSION at least
C           ( 1 + ( n - 1 )*abs( INCX ) ) when TRANS = 'N' or 'n'
C           and at least
C           ( 1 + ( m - 1 )*abs( INCX ) ) otherwise.
C           Before entry, the incremented array X must contain the
C           vector x.
C           Unchanged on exit.
C
C  INCX   - INTEGER.
C           On entry, INCX specifies the increment for the elements of
C           X. INCX must not be zero.
C           Unchanged on exit.
C
C  BETA   - DOUBLE PRECISION.
C           On entry, BETA specifies the scalar beta. When BETA is
C           supplied as zero then Y need not be set on input.
C           Unchanged on exit.
C
C  Y      - DOUBLE PRECISION array of DIMENSION at least
C           ( 1 + ( m - 1 )*abs( INCY ) ) when TRANS = 'N' or 'n'
C           and at least
C           ( 1 + ( n - 1 )*abs( INCY ) ) otherwise.
C           Before entry with BETA non-zero, the incremented array Y
C           must contain the vector y. On exit, Y is overwritten by the
C           updated vector y.
C
C  INCY   - INTEGER.
C           On entry, INCY specifies the increment for the elements of
C           Y. INCY must not be zero.
C           Unchanged on exit.
C
C
C  Level 2 Blas routine.
C
C  -- Written on 22-October-1986.
C     Jack Dongarra, Argonne National Lab.
C     Jeremy Du Croz, Nag Central Office.
C     Sven Hammarling, Nag Central Office.
C     Richard Hanson, Sandia National Labs.
C  -- DO-loops unrolled on 20-November-1986.
C     Peter Mayes, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ONE         , ZERO
      PARAMETER        ( ONE = 1.0D+0, ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   TEMP, TEMP1, TEMP2, TEMP3, TEMP4
      INTEGER            I, INFO, IY, J, JX, KX, KY, LENX, LENY, M4, N4
C     .. External Subroutines ..
      EXTERNAL           F06AAZ
C     .. Intrinsic Functions ..
      INTRINSIC          MAX
C     ..
C     .. Executable Statements ..
C
C     Test the input parameters.
C
      INFO = 0
      IF     ( .NOT.(TRANS.EQ.'N' .OR. TRANS.EQ.'n').AND.
     $         .NOT.(TRANS.EQ.'T' .OR. TRANS.EQ.'t').AND.
     $         .NOT.(TRANS.EQ.'C' .OR. TRANS.EQ.'c')      )THEN
         INFO = 1
      ELSE IF( M.LT.0 )THEN
         INFO = 2
      ELSE IF( N.LT.0 )THEN
         INFO = 3
      ELSE IF( LDA.LT.MAX( 1, M ) )THEN
         INFO = 6
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 8
      ELSE IF( INCY.EQ.0 )THEN
         INFO = 11
      END IF
      IF( INFO.NE.0 )THEN
         CALL F06AAZ( 'F06PAF/DGEMV ', INFO )
         RETURN
      END IF
C
C     Quick return if possible.
C
      IF( ( M.EQ.0 ).OR.( N.EQ.0 ).OR.
     $    ( ( ALPHA.EQ.ZERO ).AND.( BETA.EQ.ONE ) ) )
     $   RETURN
C
C     Set  LENX  and  LENY, the lengths of the vectors x and y, and set
C     up the start points in  X  and  Y.
C
      IF( (TRANS.EQ.'N' .OR. TRANS.EQ.'n') )THEN
         LENX = N
         LENY = M
      ELSE
         LENX = M
         LENY = N
      END IF
      IF( INCX.GT.0 )THEN
         KX = 1
      ELSE
         KX = 1 - ( LENX - 1 )*INCX
      END IF
      IF( INCY.GT.0 )THEN
         KY = 1
      ELSE
         KY = 1 - ( LENY - 1 )*INCY
      END IF
C
C     Start the operations. In this version the inner loops are all
C     equivalent to AXPY operations.
C
C     First form  y := beta*y.
C
      IF( BETA.NE.ONE )THEN
         IF( INCY.EQ.1 )THEN
            IF( BETA.EQ.ZERO )THEN
               DO 10, I = 1, LENY
                  Y( I ) = ZERO
   10          CONTINUE
            ELSE
               DO 20, I = 1, LENY
                  Y( I ) = BETA*Y( I )
   20          CONTINUE
            END IF
         ELSE
            IY = KY
            IF( BETA.EQ.ZERO )THEN
               DO 30, I = 1, LENY
                  Y( IY ) = ZERO
                  IY      = IY   + INCY
   30          CONTINUE
            ELSE
               DO 40, I = 1, LENY
                  Y( IY ) = BETA*Y( IY )
                  IY      = IY           + INCY
   40          CONTINUE
            END IF
         END IF
      END IF
      IF( ALPHA.EQ.ZERO )
     $   RETURN
      JX = KX
      IF( (TRANS.EQ.'N' .OR. TRANS.EQ.'n') )THEN
C
C        Form  y := alpha*A*x + y.
C
         IF( INCY.EQ.1 )THEN
C**** U n r o l l   t o   d e p t h   4 ********************************
            N4 = 4*( N/4 )
            DO 60, J = 1, N4, 4
               TEMP1 = ALPHA*X( JX )
               TEMP2 = ALPHA*X( JX + INCX )
               TEMP3 = ALPHA*X( JX + 2*INCX )
               TEMP4 = ALPHA*X( JX + 3*INCX )
               IF( TEMP1.NE.ZERO.OR.TEMP2.NE.ZERO.OR.TEMP3.NE.ZERO.OR.
     $             TEMP4.NE.ZERO )THEN
                  DO 50, I = 1, M
                     Y( I ) = ( ( ( ( Y( I ) + TEMP1*A( I, J ) )
     $                        + TEMP2*A( I, J + 1 ) )
     $                        + TEMP3*A( I, J + 2 ) )
     $                        + TEMP4*A( I, J + 3 ) )
   50             CONTINUE
               END IF
               JX = JX + 4*INCX
   60       CONTINUE
C**** Clean-up loop ****************************************************
            DO 80, J = N4 + 1, N, 1
               TEMP = ALPHA*X( JX )
               IF( TEMP.NE.ZERO )THEN
                  DO 70, I = 1, M
                     Y( I ) = Y( I ) + TEMP*A( I, J )
   70             CONTINUE
               END IF
               JX = JX + INCX
   80       CONTINUE
         ELSE
C**** U n r o l l   t o   d e p t h   4 ********************************
            N4 = 4*( N/4 )
            DO 100, J = 1, N4, 4
               TEMP1 = ALPHA*X( JX )
               TEMP2 = ALPHA*X( JX + INCX )
               TEMP3 = ALPHA*X( JX + 2*INCX )
               TEMP4 = ALPHA*X( JX + 3*INCX )
               IF( TEMP1.NE.ZERO.OR.TEMP2.NE.ZERO.OR.TEMP3.NE.ZERO.OR.
     $             TEMP4.NE.ZERO )THEN
                  IY = KY
                  DO 90, I = 1, M
                     Y( IY ) = ( ( ( ( Y( IY ) + TEMP1*A( I, J ) )
     $                         + TEMP2*A( I, J + 1 ) )
     $                         + TEMP3*A( I, J + 2 ) )
     $                         + TEMP4*A( I, J + 3 ) )
                     IY = IY + INCY
   90             CONTINUE
               END IF
               JX = JX + 4*INCX
  100       CONTINUE
C**** Clean-up loop ****************************************************
            DO 120, J = N4 + 1, N, 1
               IF( X( JX ).NE.ZERO )THEN
                  TEMP = ALPHA*X( JX )
                  IY = KY
                  DO 110, I = 1, M
                     Y( IY ) = Y( IY ) + TEMP*A( I, J )
                     IY = IY + INCY
  110             CONTINUE
               END IF
               JX = JX + INCX
  120       CONTINUE
         END IF
      ELSE
C
C        Form  y := alpha*A'*x + y.
C
         IF( INCY.EQ.1 )THEN
C**** U n r o l l   t o   d e p t h   4 ********************************
            M4 = 4*( M/4 )
            DO 140, J = 1, M4, 4
               TEMP1 = ALPHA*X( JX )
               TEMP2 = ALPHA*X( JX + INCX )
               TEMP3 = ALPHA*X( JX + 2*INCX )
               TEMP4 = ALPHA*X( JX + 3*INCX )
               IF( TEMP1.NE.ZERO.OR.TEMP2.NE.ZERO.OR.TEMP3.NE.ZERO.OR.
     $             TEMP4.NE.ZERO )THEN
                  DO 130, I = 1, N
                     Y( I ) = ( ( ( ( Y( I ) + TEMP1*A( J, I ) )
     $                        + TEMP2*A( J + 1, I ) )
     $                        + TEMP3*A( J + 2, I ) )
     $                        + TEMP4*A( J + 3, I ) )
  130             CONTINUE
               END IF
               JX = JX + 4*INCX
  140       CONTINUE
C**** Clean-up loop ****************************************************
            DO 160, J = M4 + 1, M, 1
               TEMP = ALPHA*X( JX )
               IF( TEMP.NE.ZERO )THEN
                  DO 150, I = 1, N
                     Y( I ) = Y( I ) + TEMP*A( J, I )
  150             CONTINUE
               END IF
               JX = JX + INCX
  160       CONTINUE
         ELSE
C**** U n r o l l   t o   d e p t h   4 ********************************
            M4 = 4*( M/4 )
            DO 180, J = 1, M4, 4
               TEMP1 = ALPHA*X( JX )
               TEMP2 = ALPHA*X( JX + INCX )
               TEMP3 = ALPHA*X( JX + 2*INCX )
               TEMP4 = ALPHA*X( JX + 3*INCX )
               IF( TEMP1.NE.ZERO.OR.TEMP2.NE.ZERO.OR.TEMP3.NE.ZERO.OR.
     $             TEMP4.NE.ZERO )THEN
                  IY = KY
                  DO 170, I = 1, N
                     Y( IY ) = ( ( ( ( Y( IY ) + TEMP1*A( J, I ) )
     $                         + TEMP2*A( J + 1, I ) )
     $                         + TEMP3*A( J + 2, I ) )
     $                         + TEMP4*A( J + 3, I ) )
                     IY = IY + INCY
  170             CONTINUE
               END IF
               JX = JX + 4*INCX
  180       CONTINUE
C**** Clean-up loop ****************************************************
            DO 200, J = M4 + 1, M, 1
               IF( X( JX ).NE.ZERO )THEN
                  TEMP = ALPHA*X( JX )
                  IY = KY
                  DO 190, I = 1, N
                     Y( IY ) = Y( IY ) + TEMP*A( J, I )
                     IY = IY + INCY
  190             CONTINUE
               END IF
               JX = JX + INCX
  200       CONTINUE
         END IF
      END IF
C
      RETURN
C
C     End of F06PAF (DGEMV ).
C
      END
      INTEGER FUNCTION P01ABF(IFAIL,IERROR,SRNAME,NREC,REC)
C     MARK 11.5(F77) RELEASE. NAG COPYRIGHT 1986.
C     MARK 13 REVISED. IER-621 (APR 1988).
C     MARK 13B REVISED. IER-668 (AUG 1988).
C
C     P01ABF is the error-handling routine for the NAG Library.
C
C     P01ABF either returns the value of IERROR through the routine
C     name (soft failure), or terminates execution of the program
C     (hard failure). Diagnostic messages may be output.
C
C     If IERROR = 0 (successful exit from the calling routine),
C     the value 0 is returned through the routine name, and no
C     message is output
C
C     If IERROR is non-zero (abnormal exit from the calling routine),
C     the action taken depends on the value of IFAIL.
C
C     IFAIL =  1: soft failure, silent exit (i.e. no messages are 
C                 output)
C     IFAIL = -1: soft failure, noisy exit (i.e. messages are output)
C     IFAIL =-13: soft failure, noisy exit but standard messages from
C                 P01ABF are suppressed
C     IFAIL =  0: hard failure, noisy exit
C
C     For compatibility with certain routines included before Mark 12
C     P01ABF also allows an alternative specification of IFAIL in which
C     it is regarded as a decimal integer with least significant digits
C     cba. Then
C
C     a = 0: hard failure  a = 1: soft failure
C     b = 0: silent exit   b = 1: noisy exit
C
C     except that hard failure now always implies a noisy exit.
C
C     S.Hammarling, M.P.Hooper and J.J.du Croz, NAG Central Office.
C
C     .. Scalar Arguments ..
      INTEGER                 IERROR, IFAIL, NREC
      CHARACTER*(*)           SRNAME
C     .. Array Arguments ..
      CHARACTER*(*)           REC(*)
C     .. Local Scalars ..
      INTEGER                 I, NERR
      CHARACTER*72            MESS
C     .. External Subroutines ..
      EXTERNAL                P01ABZ, X04AAF, X04BAF
C     .. Intrinsic Functions ..
      INTRINSIC               ABS, MOD
C     .. Executable Statements ..
      IF (IERROR.NE.0) THEN
C        Abnormal exit from calling routine
         IF (IFAIL.EQ.-1 .OR. IFAIL.EQ.0 .OR. IFAIL.EQ.-13 .OR.
     *       (IFAIL.GT.0 .AND. MOD(IFAIL/10,10).NE.0)) THEN
C           Noisy exit
            CALL X04AAF(0,NERR)
            DO 20 I = 1, NREC
               CALL X04BAF(NERR,REC(I))
   20       CONTINUE
            IF (IFAIL.NE.-13) THEN
               WRITE (MESS,FMT=99999) SRNAME, IERROR
               CALL X04BAF(NERR,MESS)
               IF (ABS(MOD(IFAIL,10)).NE.1) THEN
C                 Hard failure
                  CALL X04BAF(NERR,
     *                     ' ** NAG hard failure - execution terminated'
     *                        )
                  CALL P01ABZ
               ELSE
C                 Soft failure
                  CALL X04BAF(NERR,
     *                        ' ** NAG soft failure - control returned')
               END IF
            END IF
         END IF
      END IF
      P01ABF = IERROR
      RETURN
C
99999 FORMAT (' ** ABNORMAL EXIT from NAG Library routine ',A,': IFAIL',
     *  ' =',I6)
      END
      SUBROUTINE P01ABZ
C     MARK 11.5(F77) RELEASE. NAG COPYRIGHT 1986.
C
C     Terminates execution when a hard failure occurs.
C
C     ******************** IMPLEMENTATION NOTE ********************
C     The following STOP statement may be replaced by a call to an
C     implementation-dependent routine to display a message and/or
C     to abort the program.
C     *************************************************************
C     .. Executable Statements ..
      STOP
      END
      DOUBLE PRECISION FUNCTION A02ABF(XXR,XXI)
C     NAG COPYRIGHT 1975
C     MARK 4.5 REVISED
C     MARK 5C REVISED
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     RETURNS THE ABSOLUTE VALUE OF A COMPLEX NUMBER VIA ROUTINE
C     NAME
C
C     .. Scalar Arguments ..
      DOUBLE PRECISION                 XXI, XXR
C     .. Local Scalars ..
      DOUBLE PRECISION                 H, ONE, XI, XR, ZERO
C     .. Intrinsic Functions ..
      INTRINSIC                        ABS, SQRT
C     .. Data statements ..
      DATA                             ZERO/0.0D0/, ONE/1.0D0/
C     .. Executable Statements ..
C
      XR = ABS(XXR)
      XI = ABS(XXI)
      IF (XI.LE.XR) GO TO 20
      H = XR
      XR = XI
      XI = H
   20 IF (XI.NE.ZERO) GO TO 40
      A02ABF = XR
      RETURN
   40 H = XR*SQRT(ONE+(XI/XR)**2)
      A02ABF = H
      RETURN
      END
      SUBROUTINE A02ACF(XXR,XXI,YYR,YYI,ZR,ZI)
C     MARK 2A RELEASE.  NAG COPYRIGHT 1973
C     MARK 4.5 REVISED
C     MARK 5C REVISED
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     DIVIDES ONE COMPLEX NUMBER BY A SECOND
C
C     .. Scalar Arguments ..
      DOUBLE PRECISION  XXI, XXR, YYI, YYR, ZI, ZR
C     .. Local Scalars ..
      DOUBLE PRECISION  A, H, ONE
C     .. Intrinsic Functions ..
      INTRINSIC         ABS
C     .. Data statements ..
      DATA              ONE/1.0D0/
C     .. Executable Statements ..
C
      IF (ABS(YYR).LE.ABS(YYI)) GO TO 20
      H = YYI/YYR
      A = ONE/(H*YYI+YYR)
      ZR = (XXR+H*XXI)*A
      ZI = (XXI-H*XXR)*A
      RETURN
   20 H = YYR/YYI
      A = ONE/(H*YYR+YYI)
      ZR = (H*XXR+XXI)*A
      ZI = (H*XXI-XXR)*A
      RETURN
      END
      DOUBLE PRECISION FUNCTION X02AJF()
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C
C     RETURNS  (1/2)*B**(1-P)  IF ROUNDS IS .TRUE.
C     RETURNS  B**(1-P)  OTHERWISE
C
      DOUBLE PRECISION X02CON
!      DATA X02CON /Z'3CA0000000000001' /
C     .. Executable Statements ..
      X02AJF = epsilon(X02CON)
      RETURN
      END
      INTEGER FUNCTION X02BHF()
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C
C     RETURNS THE MODEL PARAMETER, B.
C
C     .. Executable Statements ..
      X02BHF =     2
      RETURN
      END
      DOUBLE PRECISION FUNCTION X02AKF()
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C
C     RETURNS  B**(EMIN-1)  (THE SMALLEST POSITIVE MODEL NUMBER)
C
      DOUBLE PRECISION X02CON
!      DATA X02CON /Z'0010000000000000' /
C     .. Executable Statements ..
      X02AKF = tiny(X02CON)
      RETURN
      END
      SUBROUTINE X04AAF(I,NERR)
C     MARK 7 RELEASE. NAG COPYRIGHT 1978
C     MARK 7C REVISED IER-190 (MAY 1979)
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     IF I = 0, SETS NERR TO CURRENT ERROR MESSAGE UNIT NUMBER
C     (STORED IN NERR1).
C     IF I = 1, CHANGES CURRENT ERROR MESSAGE UNIT NUMBER TO
C     VALUE SPECIFIED BY NERR.
C
C     .. Scalar Arguments ..
      INTEGER           I, NERR
C     .. Local Scalars ..
      INTEGER           NERR1
C     .. Save statement ..
      SAVE              NERR1
C     .. Data statements ..
      DATA              NERR1/0/
C     .. Executable Statements ..
      IF (I.EQ.0) NERR = NERR1
      IF (I.EQ.1) NERR1 = NERR
      RETURN
      END
      SUBROUTINE X04BAF(NOUT,REC)
C     MARK 11.5(F77) RELEASE. NAG COPYRIGHT 1986.
C
C     X04BAF writes the contents of REC to the unit defined by NOUT.
C
C     Trailing blanks are not output, except that if REC is entirely
C     blank, a single blank character is output.
C     If NOUT.lt.0, i.e. if NOUT is not a valid Fortran unit identifier,
C     then no output occurs.
C
C     .. Scalar Arguments ..
      INTEGER           NOUT
      CHARACTER*(*)     REC
C     .. Local Scalars ..
      INTEGER           I
C     .. Intrinsic Functions ..
      INTRINSIC         LEN
C     .. Executable Statements ..
      IF (NOUT.GE.0) THEN
C        Remove trailing blanks
         DO 20 I = LEN(REC), 2, -1
            IF (REC(I:I).NE.' ') GO TO 40
   20    CONTINUE
C        Write record to external file
   40    WRITE (NOUT,FMT=99999) REC(1:I)
      END IF
      RETURN
C
99999 FORMAT (A)
      END
      SUBROUTINE F06PJF( UPLO, TRANS, DIAG, N, A, LDA, X, INCX )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     AXP4 VERSION FOR VECTOR MACHINES
C     .. Entry Points ..
      ENTRY      DTRSV ( UPLO, TRANS, DIAG, N, A, LDA, X, INCX )
C     .. Scalar Arguments ..
      INTEGER            INCX, LDA, N
      CHARACTER*1        DIAG, TRANS, UPLO
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), X( * )
C     ..
C
C  Purpose
C  =======
C
C  DTRSV  solves one of the systems of equations
C
C     A*x = b,   or   A'*x = b,
C
C  where b and x are n element vectors and A is an n by n unit, or
C  non-unit, upper or lower triangular matrix.
C
C  No test for singularity or near-singularity is included in this
C  routine. Such tests must be performed before calling this routine.
C
C  Parameters
C  ==========
C
C  UPLO   - CHARACTER*1.
C           On entry, UPLO specifies whether the matrix is an upper or
C           lower triangular matrix as follows:
C
C              UPLO = 'U' or 'u'   A is an upper triangular matrix.
C
C              UPLO = 'L' or 'l'   A is a lower triangular matrix.
C
C           Unchanged on exit.
C
C  TRANS  - CHARACTER*1.
C           On entry, TRANS specifies the equations to be solved as
C           follows:
C
C              TRANS = 'N' or 'n'   A*x = b.
C
C              TRANS = 'T' or 't'   A'*x = b.
C
C              TRANS = 'C' or 'c'   A'*x = b.
C
C           Unchanged on exit.
C
C  DIAG   - CHARACTER*1.
C           On entry, DIAG specifies whether or not A is unit
C           triangular as follows:
C
C              DIAG = 'U' or 'u'   A is assumed to be unit triangular.
C
C              DIAG = 'N' or 'n'   A is not assumed to be unit
C                                  triangular.
C
C           Unchanged on exit.
C
C  N      - INTEGER.
C           On entry, N specifies the order of the matrix A.
C           N must be at least zero.
C           Unchanged on exit.
C
C  A      - DOUBLE PRECISION array of DIMENSION ( LDA, n ).
C           Before entry with  UPLO = 'U' or 'u', the leading n by n
C           upper triangular part of the array A must contain the upper
C           triangular matrix and the strictly lower triangular part of
C           A is not referenced.
C           Before entry with UPLO = 'L' or 'l', the leading n by n
C           lower triangular part of the array A must contain the lower
C           triangular matrix and the strictly upper triangular part of
C           A is not referenced.
C           Note that when  DIAG = 'U' or 'u', the diagonal elements of
C           A are not referenced either, but are assumed to be unity.
C           Unchanged on exit.
C
C  LDA    - INTEGER.
C           On entry, LDA specifies the first dimension of A as declared
C           in the calling (sub) program. LDA must be at least
C           max( 1, n ).
C           Unchanged on exit.
C
C  X      - DOUBLE PRECISION array of dimension at least
C           ( 1 + ( n - 1 )*abs( INCX ) ).
C           Before entry, the incremented array X must contain the n
C           element right-hand side vector b. On exit, X is overwritten
C           with the solution vector x.
C
C  INCX   - INTEGER.
C           On entry, INCX specifies the increment for the elements of
C           X. INCX must not be zero.
C           Unchanged on exit.
C
C
C  Level 2 Blas routine.
C
C  -- Written on 22-October-1986.
C     Jack Dongarra, Argonne National Lab.
C     Jeremy Du Croz, Nag Central Office.
C     Sven Hammarling, Nag Central Office.
C     Richard Hanson, Sandia National Labs.
C  -- DO-loops unrolled on 20-November-1986.
C     Peter Mayes, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER        ( ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   TEMP1, TEMP2, TEMP3, TEMP4
      INTEGER            I, INFO, IX, J, JX, KX, N4
      LOGICAL            NOUNIT
C     .. External Subroutines ..
      EXTERNAL           F06AAZ
C     .. Intrinsic Functions ..
      INTRINSIC          MAX, MOD
C     ..
C     .. Executable Statements ..
C
C     Test the input parameters.
C
      INFO = 0
      IF     ( .NOT.(UPLO .EQ.'U' .OR. UPLO .EQ.'u').AND.
     $         .NOT.(UPLO .EQ.'L' .OR. UPLO .EQ.'l')      )THEN
         INFO = 1
      ELSE IF( .NOT.(TRANS.EQ.'N' .OR. TRANS.EQ.'n').AND.
     $         .NOT.(TRANS.EQ.'T' .OR. TRANS.EQ.'t').AND.
     $         .NOT.(TRANS.EQ.'C' .OR. TRANS.EQ.'c')      )THEN
         INFO = 2
      ELSE IF( .NOT.(DIAG .EQ.'U' .OR. DIAG .EQ.'u').AND.
     $         .NOT.(DIAG .EQ.'N' .OR. DIAG .EQ.'n')      )THEN
         INFO = 3
      ELSE IF( N.LT.0 )THEN
         INFO = 4
      ELSE IF( LDA.LT.MAX( 1, N ) )THEN
         INFO = 6
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 8
      END IF
      IF( INFO.NE.0 )THEN
         CALL F06AAZ( 'F06PJF/DTRSV ', INFO )
         RETURN
      END IF
C
C     Quick return if possible.
C
      IF( N.EQ.0 )
     $   RETURN
C
      NOUNIT = (DIAG.EQ.'N' .OR. DIAG.EQ.'n')
C
C     Set up the start point in X if the increment is not unity. This
C     will be  ( N - 1 )*INCX  too small for descending loops.
C
      IF( INCX.LE.0 )THEN
         KX = 1 - ( N - 1 )*INCX
      ELSE IF( INCX.NE.1 )THEN
         KX = 1
      END IF
C
C     Start the operations. In this version the inner loops are all
C     equivalent to AXPY operations.
C
      IF( (TRANS.EQ.'N' .OR. TRANS.EQ.'n') )THEN
C
C        Form  x := inv( A )*x.
C
         IF( (UPLO.EQ.'U' .OR. UPLO.EQ.'u') )THEN
            IF( INCX.EQ.1 )THEN
C**** U n r o l l   t o   D e p t h  4 ********** L O O P  A ***********
               N4 = MOD( N, 4 ) + 1
               DO 20, J = N, N4, -4
C**** 4 by 4 triangle at bottom of block *******************************
                  IF( NOUNIT )
     $               X( J ) = X( J )/A( J, J )
                  X( J - 1 ) = X( J - 1 ) - X( J )*A( J - 1, J )
                  IF( NOUNIT )
     $               X( J - 1 ) = X( J - 1 )/A( J - 1, J - 1 )
                  X( J - 2 ) = X( J - 2 ) - X( J )*A( J - 2, J ) -
     $                         X( J - 1 )*A( J - 2, J - 1 )
                  IF( NOUNIT )
     $               X( J - 2 ) = X( J - 2 )/A( J - 2, J - 2 )
                  X( J - 3 ) = X( J - 3 ) - X( J )*A( J - 3, J ) -
     $                         X( J - 1 )*A( J - 3, J - 1 ) - X( J - 2 )
     $                         *A( J - 3, J - 2 )
                  IF( NOUNIT )
     $               X( J - 3 ) = X( J - 3 )/A( J - 3, J - 3 )
C**** Unrolled main loop ***********************************************
                  TEMP1 = X( J )
                  TEMP2 = X( J - 1 )
                  TEMP3 = X( J - 2 )
                  TEMP4 = X( J - 3 )
                  IF( TEMP1.NE.ZERO.OR.TEMP2.NE.ZERO.OR.TEMP3.NE.
     $                ZERO.OR.TEMP4.NE.ZERO )THEN
                     DO 10, I = J - 4, 1, -1
                        X( I ) = ( ( ( ( X( I ) - TEMP1*A( I, J ) )
     $                           - TEMP2*A( I, J - 1 ) )
     $                           - TEMP3*A( I, J - 2 ) )
     $                           - TEMP4*A( I, J - 3 ) )
   10                CONTINUE
                  END IF
   20          CONTINUE
C**** Left-overs on top left corner ************************************
               IF( N4.GE.2 )THEN
                  IF( NOUNIT )
     $               X( N4 - 1 ) = X( N4 - 1 )/A( N4 - 1, N4 - 1 )
               END IF
               IF( N4.GE.3 )THEN
                  X( N4 - 2 ) = X( N4 - 2 ) - X( N4 - 1 )
     $                          *A( N4 - 2, N4 - 1 )
                  IF( NOUNIT )
     $               X( N4 - 2 ) = X( N4 - 2 )/A( N4 - 2, N4 - 2 )
               END IF
               IF( N4.GE.4 )THEN
                  X( N4 - 3 ) = X( N4 - 3 ) - X( N4 - 1 )
     $                          *A( N4 - 3, N4 - 1 ) - X( N4 - 2 )
     $                          *A( N4 - 3, N4 - 2 )
                  IF( NOUNIT )
     $               X( N4 - 3 ) = X( N4 - 3 )/A( N4 - 3, N4 - 3 )
               END IF
            ELSE
               JX = KX + ( N - 1 )*INCX
C**** U n r o l l   t o   D e p t h  4 ********** L O O P  B ***********
               N4 = MOD( N, 4 ) + 1
               DO 40, J = N, N4, -4
C**** 4 by 4 triangle at bottom of block *******************************
                  IF( NOUNIT )
     $               X( JX ) = X( JX )/A( J, J )
                  X( JX - INCX ) = X( JX - INCX ) - X( JX )
     $                             *A( J - 1, J )
                  IF( NOUNIT )
     $               X( JX - INCX ) = X( JX - INCX )/A( J - 1, J - 1 )
                  X( JX - 2*INCX ) = X( JX - 2*INCX ) - X( JX )
     $                               *A( J - 2, J ) - X( JX - INCX )
     $                               *A( J - 2, J - 1 )
                  IF( NOUNIT )
     $               X( JX - 2*INCX ) = X( JX - 2*INCX )
     $                                  /A( J - 2, J - 2 )
                  X( JX - 3*INCX ) = X( JX - 3*INCX ) - X( JX )
     $                               *A( J - 3, J ) - X( JX - INCX )
     $                               *A( J - 3, J - 1 ) -
     $                               X( JX - 2*INCX )*A( J - 3, J - 2 )
                  IF( NOUNIT )
     $               X( JX - 3*INCX ) = X( JX - 3*INCX )
     $                                  /A( J - 3, J - 3 )
C**** Unrolled main loop ***********************************************
                  TEMP1 = X( JX )
                  TEMP2 = X( JX - INCX )
                  TEMP3 = X( JX - 2*INCX )
                  TEMP4 = X( JX - 3*INCX )
                  IF( TEMP1.NE.ZERO.OR.TEMP2.NE.ZERO.OR.TEMP3.NE.
     $                ZERO.OR.TEMP4.NE.ZERO )THEN
                     IX = JX - 3*INCX
                     DO 30, I = J - 4, 1, -1
                        IX = IX - INCX
                        X( IX ) = ( ( ( ( X( IX ) - TEMP1*A( I, J ) )
     $                            - TEMP2*A( I, J - 1 ) )
     $                            - TEMP3*A( I, J - 2 ) )
     $                            - TEMP4*A( I, J - 3 ) )
   30                CONTINUE
                  END IF
                  JX = JX - 4*INCX
   40          CONTINUE
C**** Left-overs on top left corner ************************************
               IF( N4.GE.2 )THEN
                  IF( NOUNIT )
     $               X( JX ) = X( JX )/A( N4 - 1, N4 - 1 )
               END IF
               IF( N4.GE.3 )THEN
                  X( JX - INCX ) = X( JX - INCX ) - X( JX )
     $                             *A( N4 - 2, N4 - 1 )
                  IF( NOUNIT )
     $               X( JX - INCX ) = X( JX - INCX )/A( N4 - 2, N4 - 2 )
               END IF
               IF( N4.GE.4 )THEN
                  X( JX - 2*INCX ) = X( JX - 2*INCX ) - X( JX )
     $                               *A( N4 - 3, N4 - 1 ) -
     $                               X( JX - INCX )*A( N4 - 3, N4 - 2 )
                  IF( NOUNIT )
     $               X( JX - 2*INCX ) = X( JX - 2*INCX )
     $                                  /A( N4 - 3, N4 - 3 )
               END IF
            END IF
         ELSE
            IF( INCX.EQ.1 )THEN
C**** U n r o l l   t o   D e p t h  4 ********** L O O P  C ***********
               N4 = 4*( N/4 )
               DO 60, J = 1, N4, 4
C**** 4 by 4 triangle at bottom of block *******************************
                  IF( NOUNIT )
     $               X( J ) = X( J )/A( J, J )
                  X( J + 1 ) = X( J + 1 ) - X( J )*A( J + 1, J )
                  IF( NOUNIT )
     $               X( J + 1 ) = X( J + 1 )/A( J + 1, J + 1 )
                  X( J + 2 ) = X( J + 2 ) - X( J )*A( J + 2, J ) -
     $                         X( J + 1 )*A( J + 2, J + 1 )
                  IF( NOUNIT )
     $               X( J + 2 ) = X( J + 2 )/A( J + 2, J + 2 )
                  X( J + 3 ) = X( J + 3 ) - X( J )*A( J + 3, J ) -
     $                         X( J + 1 )*A( J + 3, J + 1 ) - X( J + 2 )
     $                         *A( J + 3, J + 2 )
                  IF( NOUNIT )
     $               X( J + 3 ) = X( J + 3 )/A( J + 3, J + 3 )
C**** Unrolled main loop ***********************************************
                  TEMP1 = X( J )
                  TEMP2 = X( J + 1 )
                  TEMP3 = X( J + 2 )
                  TEMP4 = X( J + 3 )
                  IF( TEMP1.NE.ZERO.OR.TEMP2.NE.ZERO.OR.TEMP3.NE.
     $                ZERO.OR.TEMP4.NE.ZERO )THEN
                     DO 50, I = J + 4, N
                        X( I ) = ( ( ( ( X( I ) - TEMP1*A( I, J ) )
     $                           - TEMP2*A( I, J + 1 ) )
     $                           - TEMP3*A( I, J + 2 ) )
     $                           - TEMP4*A( I, J + 3 ) )
   50                CONTINUE
                  END IF
   60          CONTINUE
C**** Left-overs on top left corner ************************************
               IF( N4 + 1.LE.N )THEN
                  IF( NOUNIT )
     $               X( N4 + 1 ) = X( N4 + 1 )/A( N4 + 1, N4 + 1 )
               END IF
               IF( N4 + 2.LE.N )THEN
                  X( N4 + 2 ) = X( N4 + 2 ) - X( N4 + 1 )
     $                          *A( N4 + 2, N4 + 1 )
                  IF( NOUNIT )
     $               X( N4 + 2 ) = X( N4 + 2 )/A( N4 + 2, N4 + 2 )
               END IF
               IF( N4 + 3.LE.N )THEN
                  X( N4 + 3 ) = X( N4 + 3 ) - X( N4 + 1 )
     $                          *A( N4 + 3, N4 + 1 ) - X( N4 + 2 )
     $                          *A( N4 + 3, N4 + 2 )
                  IF( NOUNIT )
     $               X( N4 + 3 ) = X( N4 + 3 )/A( N4 + 3, N4 + 3 )
               END IF
            ELSE
               JX = KX
C**** U n r o l l   t o   D e p t h  4 ********** L O O P  D ***********
               N4 = 4*( N/4 )
               DO 80, J = 1, N4, 4
C**** 4 by 4 triangle at bottom of block *******************************
                  IF( NOUNIT )
     $               X( JX ) = X( JX )/A( J, J )
                  X( JX + INCX ) = X( JX + INCX ) - X( JX )
     $                             *A( J + 1, J )
                  IF( NOUNIT )
     $               X( JX + INCX ) = X( JX + INCX )/A( J + 1, J + 1 )
                  X( JX + 2*INCX ) = X( JX + 2*INCX ) - X( JX )
     $                               *A( J + 2, J ) - X( JX + INCX )
     $                               *A( J + 2, J + 1 )
                  IF( NOUNIT )
     $               X( JX + 2*INCX ) = X( JX + 2*INCX )
     $                                  /A( J + 2, J + 2 )
                  X( JX + 3*INCX ) = X( JX + 3*INCX ) - X( JX )
     $                               *A( J + 3, J ) - X( JX + INCX )
     $                               *A( J + 3, J + 1 ) -
     $                               X( JX + 2*INCX )*A( J + 3, J + 2 )
                  IF( NOUNIT )
     $               X( JX + 3*INCX ) = X( JX + 3*INCX )
     $                                  /A( J + 3, J + 3 )
C**** Unrolled main loop ***********************************************
                  TEMP1 = X( JX )
                  TEMP2 = X( JX + INCX )
                  TEMP3 = X( JX + 2*INCX )
                  TEMP4 = X( JX + 3*INCX )
                  IF( TEMP1.NE.ZERO.OR.TEMP2.NE.ZERO.OR.TEMP3.NE.
     $                ZERO.OR.TEMP4.NE.ZERO )THEN
                     IX = JX + 3*INCX
                     DO 70, I = J + 4, N
                        IX = IX + INCX
                        X( IX ) = ( ( ( ( X( IX ) - TEMP1*A( I, J ) )
     $                            - TEMP2*A( I, J + 1 ) )
     $                            - TEMP3*A( I, J + 2 ) )
     $                            - TEMP4*A( I, J + 3 ) )
   70                CONTINUE
                  END IF
                  JX = JX + 4*INCX
   80          CONTINUE
C**** Left-overs on top left corner ************************************
               IF( N4 + 1.LE.N )THEN
                  IF( NOUNIT )
     $               X( JX ) = X( JX )/A( N4 + 1, N4 + 1 )
               END IF
               IF( N4 + 2.LE.N )THEN
                  X( JX + INCX ) = X( JX + INCX ) - X( JX )
     $                             *A( N4 + 2, N4 + 1 )
                  IF( NOUNIT )
     $               X( JX + INCX ) = X( JX + INCX )/A( N4 + 2, N4 + 2 )
               END IF
               IF( N4 + 3.LE.N )THEN
                  X( JX + 2*INCX ) = X( JX + 2*INCX ) - X( JX )
     $                               *A( N4 + 3, N4 + 1 ) -
     $                               X( JX + INCX )*A( N4 + 3, N4 + 2 )
                  IF( NOUNIT )
     $               X( JX + 2*INCX ) = X( JX + 2*INCX )
     $                                  /A( N4 + 3, N4 + 3 )
               END IF
            END IF
         END IF
      ELSE
C
C        Form  x := inv( A' )*x.
C
         IF( (UPLO.EQ.'U' .OR. UPLO.EQ.'u') )THEN
            IF( INCX.EQ.1 )THEN
C**** U n r o l l   t o   D e p t h  4 ********** L O O P  E ***********
               N4 = 4*( N/4 )
               DO 100, J = 1, N4, 4
C**** 4 by 4 triangle at bottom of block *******************************
                  IF( NOUNIT )
     $               X( J ) = X( J )/A( J, J )
                  X( J + 1 ) = X( J + 1 ) - X( J )*A( J, J + 1 )
                  IF( NOUNIT )
     $               X( J + 1 ) = X( J + 1 )/A( J + 1, J + 1 )
                  X( J + 2 ) = X( J + 2 ) - X( J )*A( J, J + 2 ) -
     $                         X( J + 1 )*A( J + 1, J + 2 )
                  IF( NOUNIT )
     $               X( J + 2 ) = X( J + 2 )/A( J + 2, J + 2 )
                  X( J + 3 ) = X( J + 3 ) - X( J )*A( J, J + 3 ) -
     $                         X( J + 1 )*A( J + 1, J + 3 ) - X( J + 2 )
     $                         *A( J + 2, J + 3 )
                  IF( NOUNIT )
     $               X( J + 3 ) = X( J + 3 )/A( J + 3, J + 3 )
C**** Unrolled main loop ***********************************************
                  TEMP1 = X( J )
                  TEMP2 = X( J + 1 )
                  TEMP3 = X( J + 2 )
                  TEMP4 = X( J + 3 )
                  IF( TEMP1.NE.ZERO.OR.TEMP2.NE.ZERO.OR.TEMP3.NE.
     $                ZERO.OR.TEMP4.NE.ZERO )THEN
                     DO 90, I = J + 4, N
                        X( I ) = ( ( ( ( X( I ) - TEMP1*A( J, I ) )
     $                           - TEMP2*A( J + 1, I ) )
     $                           - TEMP3*A( J + 2, I ) )
     $                           - TEMP4*A( J + 3, I ) )
   90                CONTINUE
                  END IF
  100          CONTINUE
C**** Left-overs on top left corner ************************************
               IF( N4 + 1.LE.N )THEN
                  IF( NOUNIT )
     $               X( N4 + 1 ) = X( N4 + 1 )/A( N4 + 1, N4 + 1 )
               END IF
               IF( N4 + 2.LE.N )THEN
                  X( N4 + 2 ) = X( N4 + 2 ) - X( N4 + 1 )
     $                          *A( N4 + 1, N4 + 2 )
                  IF( NOUNIT )
     $               X( N4 + 2 ) = X( N4 + 2 )/A( N4 + 2, N4 + 2 )
               END IF
               IF( N4 + 3.LE.N )THEN
                  X( N4 + 3 ) = X( N4 + 3 ) - X( N4 + 1 )
     $                          *A( N4 + 1, N4 + 3 ) - X( N4 + 2 )
     $                          *A( N4 + 2, N4 + 3 )
                  IF( NOUNIT )
     $               X( N4 + 3 ) = X( N4 + 3 )/A( N4 + 3, N4 + 3 )
               END IF
            ELSE
               JX = KX
C**** U n r o l l   t o   D e p t h  4 ********** L O O P  D ***********
               N4 = 4*( N/4 )
               DO 120, J = 1, N4, 4
C**** 4 by 4 triangle at bottom of block *******************************
                  IF( NOUNIT )
     $               X( JX ) = X( JX )/A( J, J )
                  X( JX + INCX ) = X( JX + INCX ) - X( JX )
     $                             *A( J, J + 1 )
                  IF( NOUNIT )
     $               X( JX + INCX ) = X( JX + INCX )/A( J + 1, J + 1 )
                  X( JX + 2*INCX ) = X( JX + 2*INCX ) - X( JX )
     $                               *A( J, J + 2 ) - X( JX + INCX )
     $                               *A( J + 1, J + 2 )
                  IF( NOUNIT )
     $               X( JX + 2*INCX ) = X( JX + 2*INCX )
     $                                  /A( J + 2, J + 2 )
                  X( JX + 3*INCX ) = X( JX + 3*INCX ) - X( JX )
     $                               *A( J, J + 3 ) - X( JX + INCX )
     $                               *A( J + 1, J + 3 ) -
     $                               X( JX + 2*INCX )*A( J + 2, J + 3 )
                  IF( NOUNIT )
     $               X( JX + 3*INCX ) = X( JX + 3*INCX )
     $                                  /A( J + 3, J + 3 )
C**** Unrolled main loop ***********************************************
                  TEMP1 = X( JX )
                  TEMP2 = X( JX + INCX )
                  TEMP3 = X( JX + 2*INCX )
                  TEMP4 = X( JX + 3*INCX )
                  IF( TEMP1.NE.ZERO.OR.TEMP2.NE.ZERO.OR.TEMP3.NE.
     $                ZERO.OR.TEMP4.NE.ZERO )THEN
                     IX = JX + 3*INCX
                     DO 110, I = J + 4, N
                        IX = IX + INCX
                        X( IX ) = ( ( ( ( X( IX ) - TEMP1*A( J, I ) )
     $                            - TEMP2*A( J + 1, I ) )
     $                            - TEMP3*A( J + 2, I ) )
     $                            - TEMP4*A( J + 3, I ) )
  110                CONTINUE
                  END IF
                  JX = JX + 4*INCX
  120          CONTINUE
C**** Left-overs on top left corner ************************************
               IF( N4 + 1.LE.N )THEN
                  IF( NOUNIT )
     $               X( JX ) = X( JX )/A( N4 + 1, N4 + 1 )
               END IF
               IF( N4 + 2.LE.N )THEN
                  X( JX + INCX ) = X( JX + INCX ) - X( JX )
     $                             *A( N4 + 1, N4 + 2 )
                  IF( NOUNIT )
     $               X( JX + INCX ) = X( JX + INCX )/A( N4 + 2, N4 + 2 )
               END IF
               IF( N4 + 3.LE.N )THEN
                  X( JX + 2*INCX ) = X( JX + 2*INCX ) - X( JX )
     $                               *A( N4 + 1, N4 + 3 ) -
     $                               X( JX + INCX )*A( N4 + 2, N4 + 3 )
                  IF( NOUNIT )
     $               X( JX + 2*INCX ) = X( JX + 2*INCX )
     $                                  /A( N4 + 3, N4 + 3 )
               END IF
            END IF
         ELSE
            IF( INCX.EQ.1 )THEN
C**** U n r o l l   t o   D e p t h  4 ********** L O O P  G ***********
               N4 = MOD( N, 4 ) + 1
               DO 140, J = N, N4, -4
C**** 4 by 4 triangle at bottom of block *******************************
                  IF( NOUNIT )
     $               X( J ) = X( J )/A( J, J )
                  X( J - 1 ) = X( J - 1 ) - X( J )*A( J, J - 1 )
                  IF( NOUNIT )
     $               X( J - 1 ) = X( J - 1 )/A( J - 1, J - 1 )
                  X( J - 2 ) = X( J - 2 ) - X( J )*A( J, J - 2 ) -
     $                         X( J - 1 )*A( J - 1, J - 2 )
                  IF( NOUNIT )
     $               X( J - 2 ) = X( J - 2 )/A( J - 2, J - 2 )
                  X( J - 3 ) = X( J - 3 ) - X( J )*A( J, J - 3 ) -
     $                         X( J - 1 )*A( J - 1, J - 3 ) - X( J - 2 )
     $                         *A( J - 2, J - 3 )
                  IF( NOUNIT )
     $               X( J - 3 ) = X( J - 3 )/A( J - 3, J - 3 )
C**** Unrolled main loop ***********************************************
                  TEMP1 = X( J )
                  TEMP2 = X( J - 1 )
                  TEMP3 = X( J - 2 )
                  TEMP4 = X( J - 3 )
                  IF( TEMP1.NE.ZERO.OR.TEMP2.NE.ZERO.OR.TEMP3.NE.
     $                ZERO.OR.TEMP4.NE.ZERO )THEN
                     DO 130, I = J - 4, 1, -1
                        X( I ) = ( ( ( ( X( I ) - TEMP1*A( J, I ) )
     $                           - TEMP2*A( J - 1, I ) )
     $                           - TEMP3*A( J - 2, I ) )
     $                           - TEMP4*A( J - 3, I ) )
  130                CONTINUE
                  END IF
  140          CONTINUE
C**** Left-overs on top left corner ************************************
               IF( N4.GE.2 )THEN
                  IF( NOUNIT )
     $               X( N4 - 1 ) = X( N4 - 1 )/A( N4 - 1, N4 - 1 )
               END IF
               IF( N4.GE.3 )THEN
                  X( N4 - 2 ) = X( N4 - 2 ) - X( N4 - 1 )
     $                          *A( N4 - 1, N4 - 2 )
                  IF( NOUNIT )
     $               X( N4 - 2 ) = X( N4 - 2 )/A( N4 - 2, N4 - 2 )
               END IF
               IF( N4.GE.4 )THEN
                  X( N4 - 3 ) = X( N4 - 3 ) - X( N4 - 1 )
     $                          *A( N4 - 1, N4 - 3 ) - X( N4 - 2 )
     $                          *A( N4 - 2, N4 - 3 )
                  IF( NOUNIT )
     $               X( N4 - 3 ) = X( N4 - 3 )/A( N4 - 3, N4 - 3 )
               END IF
            ELSE
               JX = KX + ( N - 1 )*INCX
C**** U n r o l l   t o   D e p t h  4 ********** L O O P  B ***********
               N4 = MOD( N, 4 ) + 1
               DO 160, J = N, N4, -4
C**** 4 by 4 triangle at bottom of block *******************************
                  IF( NOUNIT )
     $               X( JX ) = X( JX )/A( J, J )
                  X( JX - INCX ) = X( JX - INCX ) - X( JX )
     $                             *A( J, J - 1 )
                  IF( NOUNIT )
     $               X( JX - INCX ) = X( JX - INCX )/A( J - 1, J - 1 )
                  X( JX - 2*INCX ) = X( JX - 2*INCX ) - X( JX )
     $                               *A( J, J - 2 ) - X( JX - INCX )
     $                               *A( J - 1, J - 2 )
                  IF( NOUNIT )
     $               X( JX - 2*INCX ) = X( JX - 2*INCX )
     $                                  /A( J - 2, J - 2 )
                  X( JX - 3*INCX ) = X( JX - 3*INCX ) - X( JX )
     $                               *A( J, J - 3 ) - X( JX - INCX )
     $                               *A( J - 1, J - 3 ) -
     $                               X( JX - 2*INCX )*A( J - 2, J - 3 )
                  IF( NOUNIT )
     $               X( JX - 3*INCX ) = X( JX - 3*INCX )
     $                                  /A( J - 3, J - 3 )
C**** Unrolled main loop ***********************************************
                  TEMP1 = X( JX )
                  TEMP2 = X( JX - INCX )
                  TEMP3 = X( JX - 2*INCX )
                  TEMP4 = X( JX - 3*INCX )
                  IF( TEMP1.NE.ZERO.OR.TEMP2.NE.ZERO.OR.TEMP3.NE.
     $                ZERO.OR.TEMP4.NE.ZERO )THEN
                     IX = JX - 3*INCX
                     DO 150, I = J - 4, 1, -1
                        IX = IX - INCX
                        X( IX ) = ( ( ( ( X( IX ) - TEMP1*A( J, I ) )
     $                            - TEMP2*A( J - 1, I ) )
     $                            - TEMP3*A( J - 2, I ) )
     $                            - TEMP4*A( J - 3, I ) )
  150                CONTINUE
                  END IF
                  JX = JX - 4*INCX
  160          CONTINUE
C**** Left-overs on top left corner ************************************
               IF( N4.GE.2 )THEN
                  IF( NOUNIT )
     $               X( JX ) = X( JX )/A( N4 - 1, N4 - 1 )
               END IF
               IF( N4.GE.3 )THEN
                  X( JX - INCX ) = X( JX - INCX ) - X( JX )
     $                             *A( N4 - 1, N4 - 2 )
                  IF( NOUNIT )
     $               X( JX - INCX ) = X( JX - INCX )/A( N4 - 2, N4 - 2 )
               END IF
               IF( N4.GE.4 )THEN
                  X( JX - 2*INCX ) = X( JX - 2*INCX ) - X( JX )
     $                               *A( N4 - 1, N4 - 3 ) -
     $                               X( JX - INCX )*A( N4 - 2, N4 - 3 )
                  IF( NOUNIT )
     $               X( JX - 2*INCX ) = X( JX - 2*INCX )
     $                                  /A( N4 - 3, N4 - 3 )
               END IF
            END IF
         END IF
      END IF
C
      RETURN
C
C     End of F06PJF (DTRSV ).
C
      END
