c
c   F. Nunes & I. Thompson, October 1995, modified IJT, Oct 1999.
c   Calculation of the two body three body overlap
c   for a given 3 body wf in the Y hyperspherical basis, assuming the
c   hyper radial part is normalized  Integral(Xsi^2 dr)=1
c
	Subroutine Overlap32(nch2,numr2,step2,tJ2,par2,ll2,jj2,ii2,
     &	  MX,chi2, chi3,nch3max,numr3,step3,ncho,nch3,tJ3,par3,jtarg,
     X    egs,psign,bev,kky,lltoty,jstoty,ll1y,ll2y,jjny,iiy, lncmax,
     X 	  h2m,a3,xj,wj,njac,pj,mnm,maxl,mlt,ni2,ni3,s1,novplot)
	implicit real*8 (a-h,o-z)
	parameter(nch1max=4)
	real*8 chi2(MX,nch2),chi3(nch3max,numr3),probchi3(nch3max)
	real*8 chi1(nch1max,numr2),probchi2(nch2),jj2(nch2),rms2(nch2)
	integer ll2(nch2),ii2(nch2),ly1(nch1max)
	real*8 xj(njac),wj(njac),pj(0:mnm,0:maxl,-mlt:mlt,njac)
	real*8 tj(njac),chi1norm(nch1max),jtarg(10),chi1this(numr2)
	real*8 cf(21),cg(21)
	integer iiy(nch3max),kky(nch3max),lltoty(nch3max),
     &  jstoty(nch3max),ll1y(nch3max),ll2y(nch3max),jjny(nch3max)
	integer par2,par3,LLX
	logical l1,l2,l3,l4,trace,tracet,opened
        character lnames(8),psign(3)
	data lnames / 's','p','d','f','g','h','i','j' /
	parameter(trace=.false.,tracet=.false.)
	COMMON /RESCALE/ VSCALE(0:1),ZN1,ZN2,ZCORE

	aa = sqrt(a3/(a3+1.d0))
	bb = sqrt((a3+1.d0)/(a3+2.d0))
	rm = bb**2
	esep = bev-egs
	xk = sqrt(abs(esep)*rm/h2m)
      hhjac = (aa*bb)**1.5
!!	write(6,*) ' r1 coef ',a3/(a3+1.d0),
!!     X   ' r2 coef ',(a3+1.d0)/(a3+2.d0),' from ',a3,' hhjac =',hhjac
c------------------------------------------------------------
c        goto 20
   	inquire(49,opened=opened)
   	if(.not.opened) 
     &   open(49, file='wf2bodyreal', access= 'sequential',
     &      form='formatted',status='unknown')
     	write(6,*) ' TRY to read wf2bodyreal for overlaps:'
        do i2=1,nch2
        do ir=1,numr2
         read(49,*,end=20) xii2,xiir, xyyy
          chi2(ir,i2)=xyyy
        enddo
        enddo
     	write(6,*) ' Read wf2bodyreal for overlaps.'

20      inquire(48,opened=opened)
   	if(.not.opened) open(48, file='wf2body', 
     &    access= 'sequential',form='formatted',status='unknown')
        do i2=1,nch2
        do ir=1,numr2
	    r = (ir-1)*step2
          write(48,*) r,-r*chi2(ir,i2)
        enddo
          write(48,*) '&'
        enddo

c------------------------------------------------------------
	if(trace) then
c------------------------------------------------------------
c     Check normalization of chi2
c------------------------------------------------------------
	sumchi2=0.d0
	rmschi2=0.d0

	write(62,*) '# nch2 =',nch2
	write(162,*) '# nch2 =',nch2
	do i2=1,nch2
	  probchi2(i2)=0.d0
	  rms2(i2)=0.d0
	  do ir=1,numr2
	    r = (ir-1)*step2
	    probchi2(i2)=probchi2(i2)+chi2(ir,i2)**2*step2*r*r
	    rms2(i2)=rms2(i2)+chi2(ir,i2)**2*step2*r**4
	    write(62,*) real(r),chi2(ir,i2),i2
	    write(162,*) real(r),r*chi2(ir,i2)
	 	call flush(62)
	 	call flush(162)
	  enddo
	    write(62,*) '&'
	    write(162,*) '&'
	  sumchi2=sumchi2+probchi2(i2)
	  rmschi2=rmschi2+rms2(i2)
	enddo
	print*,'Norm of chi2(*):',
     &          (real(probchi2(i2)),i2=1,nch2),';',real(sumchi2)
	rmschi2 = sqrt(rmschi2/sumchi2)
	print*,'Rms of chi2(*):',
     &   (sqrt(real(rms2(i2)/probchi2(i2))),i2=1,nch2),';',real(rmschi2)
	endif
	if(tracet) then
c------------------------------------------------------------
c     Check normalization of chi3
c------------------------------------------------------------
	sumchi3=0.d0
	write(62,*) '# ncho,nch3,step3 =',ncho,nch3,step3
	ii = 0
	do i3=ncho,ncho+nch3-1
	  ii = ii+1
	  probchi3(ii)=0.d0
	  do ir=1,numr3
	    r = ir*step3
	    probchi3(ii)=probchi3(ii)+chi3(i3,ir)**2*step3
	    write(62,*) real(r),chi3(i3,ir),i3
	 	call flush(62)
	  enddo
	    write(62,*) '&'
	  sumchi3=sumchi3+probchi3(ii)
	enddo
	print*,'Norm of probchi3(*):',
     &          (real(probchi3(ii)),ii=1,nch3),';',real(sumchi3)
	endif
c------------------------------------------------------------
c     Check normalization of PJ
c------------------------------------------------------------
	if(.false.) then
	do i3=ncho,ncho+nch3-1
	   LLX=ll1y(i3)
	   LLY=ll2y(i3)
	  if(LLX.le.1) then
           	NN = mod((LLX+LLY),2)
           	LD=(LLX-LLY+NN)/2
           	N=(kky(i3)-LLX-LLY)/2
	  sumpj=0.d0
	  do j=1,njac
	    sumpj=sumpj+wj(j)*PJ(N,LLX,LD,j)**2
	  enddo
	print*,' Norm PJ:  ',i3,LLX,LLY,sumpj
	  endif
	enddo
	endif
c------------------------------------------------------------
c      Use the Jacobi polynomials in the Y basis
c------------------------------------------------------------
	sq8=sqrt(8.d0)
	do j=1,njac
	   tj(j)=0.5d0*acos(xj(j))
	enddo
c------------------------------------------------------------
c     Initialising chi1 and others
c------------------------------------------------------------
	numr1=numr2
	tk3b=sqrt(abs(egs)/20.748)
!	print*,'egs,tk3b: ',egs,tk3b
	tk3b=tk3b * step3
	do i1=1,nch1max
	  do ir1=1,numr1
	  chi1(i1,ir1)=0.d0
	  enddo
	enddo
c------------------------------------------------------------
c    Main loop over all Y 3 body channels
c------------------------------------------------------------
!	s1=0.5d0
	s2=s1
	nch1=1
	lymax=lncmax+int(tJ3)
! 	write(6,*)   ' lncmax,lymax =',lncmax,lymax
	do 100 ly=0,lymax
! 	  if(trace) write(6,*) 'try ly =',ly,';',(-1)**ly,par2,par3
          if((-1)**ly.ne.par2*par3) goto 100
	do 110 ijy=-1,1,2
	  tjy=ly+s2*ijy
	  if(s2.le.0.1.and.ijy>0) goto 110
	  if (tjy.lt.0.d0) goto 110
! 	  if(trace) write(6,*) 'try jy =',tjy,';',tJ2,tJ3
          if (tjy.lt.abs(tJ2-tJ3) .or. tjy.gt.(tJ2+tJ3))
     &    goto 110
! 	  write(6,*) 'try ly,tjy =',ly,tjy
! 	  write(6,*) 'Triangle tJ2,tjy,tJ3 =',tJ2,tjy,tJ3
	do 200 i2=1,nch2
	  tjx=jj2(i2)
	  tlx=ll2(i2)
	   LLX=ll2(i2)
	  ti=jtarg(ii2(i2))
	  slfac = (-1)**nint(tlx-s1-tjx)
	do 300 i3=ncho,ncho+nch3-1
! 	 write(6,*) 'match: ',ll2(i2),ll1y(i3),';',ii2(i2),iiy(i3),';',
!     &        ly,ll2y(i3)
	  if (ll2(i2).ne.ll1y(i3).or.ii2(i2).ne.iiy(i3).or.
     &        ly.ne.ll2y(i3)) goto 300
	  if (nch1.gt.nch1max) then
	    print*,'nch1 exceeded nch1max (overlap32)'
	    return
	  endif
! 	if(trace) write(6,*) 'try i2,i3 =',i2,i3
 	if(trace) write(6,*) 
!	 if(trace) write(6,*) 'lx,ly,i2: ',ll2(i2),ly,ii2(i2)
c------------------------------------------------------------
c     Calculating the Algebra
c------------------------------------------------------------
	  tjn=jjny(i3)
	  tly=ll2y(i3)
	  tltot=lltoty(i3)
	  tstot=jstoty(i3)
	  tkk=kky(i3)
!	  slfac2 = 1.
!	  slfac2 = (-1)**nint(tltot-tstot-tjn) 
!	  slfac2 = slfac
! 	  slfac2 = (-1)**nint(tltot-tstot-tjn) * slfac
	  if(trace) print 401,'angular:',tjx,tjy,tlx,tly,tjn,ti,
     X		tltot,tstot,tkk
	  alg1=(-1)**nint(tJ3+tJ2-tjn-tjx-2*ti)
	  alg2=(-1)**nint(tjn-tltot-tstot)
	  alg3=SIM9J(tlx,tly,tltot,
     &                   s1, s2,tstot,
     &                  tjx,tjy,tjn)
     &           *sqrt((2*tltot+1)*(2*tstot+1)*(2*tjx+1)*(2*tjy+1))
	  alg4=RACAH(ti,tjx,tJ3,tjy,tJ2,tjn)*sqrt((2*tjn+1)*(2*tJ2+1))
	  algebra = alg1 * alg2 * alg3 * alg4
	if(trace) print 402,'Algebra:',alg1,alg2,alg3,alg4,algebra,hhjac
401     format(A10,9F6.1)
402     format(A10,4F8.3,f10.5,f8.4)
	chi1this(:) = 0.0
           	NN = mod(nint(tlx+tly),2)
           	LD=nint(tlx-tly+NN)/2
           	N=nint(tkk-tlx-tly)/2
c------------------------------------------------------------
c     Calculating the Integral
c------------------------------------------------------------
	  do 400 ir1=1,numr1
	    r1=(ir1-1)*step2
	    xintegral=0.d0
	    do 410 ir2=2,numr2
	      r2=(ir2-1)*step2	      
	      y=bb*r1
	      x=aa*r2
	      rho=Sqrt(x*x + y*y)
	      jrho=int(rho/step3)
	      if(ir1>1) theta=atan(x/y)
	      if(ir1==1) theta=2d0*atan(1d0)
	      jtheta=0
	      do j=1,njac
	        if (theta.ge.tj(j)) jtheta=j
	      enddo
c------------------------------------------------------------
c     Two Dimension Interpolation of the 3body WF
c------------------------------------------------------------
	      l1=jtheta.ne.0
	      l2=jtheta.ne.njac
	      l3=jrho.ne.0
	      l4=jrho.lt.numr3
	      dthetax=0.
	      if(l1.and.l2)  dthetax=(theta-tj(jtheta))
     &				/(tj(jtheta+1)-tj(jtheta))
	      dthetay=1.d0-dthetax
	      at1=0.d0
	      at2=0.d0
	      at3=0.d0
	      at4=0.d0
	     if(.not.l4) then
	      if (l1) 
     &            at3=dthetay*chi3(i3,numr3)*exp(-tk3b*(jrho+1-numr3))
     &               *PJ(N,LLX,LD,jtheta)
	      if (l2) 
     &            at4=dthetax*chi3(i3,numr3)*exp(-tk3b*(jrho+1-numr3))
     &               *PJ(N,LLX,LD,jtheta+1)
	      chi3pj=(at3+at4)*sq8
	     else
	      dx=(rho-jrho*step3)/step3
	      dy=1.d0-dx
	      if (l1.and.l3) 
     &            at1=dthetay*chi3(i3,jrho)*PJ(N,LLX,LD,jtheta)
	      if (l2.and.l3) 
     &            at2=dthetax*chi3(i3,jrho)*PJ(N,LLX,LD,jtheta+1)
	      if (l1) 
     &            at3=dthetay*chi3(i3,jrho+1)*PJ(N,LLX,LD,jtheta)
	      if (l2) 
     &            at4=dthetax*chi3(i3,jrho+1)*PJ(N,LLX,LD,jtheta+1)
	      chi3pj=(dy*(at1+at2)+dx*(at3+at4))*sq8
	     endif
	      xintegral=xintegral+r2*step2*
     &          chi2(ir2,i2)*r2*slfac *rho**(-5.d0/2.d0)*chi3pj * hhjac
410         continue
	    chi1(nch1,ir1)=chi1(nch1,ir1)+algebra*xintegral*r1
	    chi1this(ir1)=chi1this(ir1)+algebra*xintegral*r1
c	    print*,'chi1: ',nch1,ir1,chi1(nch1,ir1)
400       continue
        chi1n = sum(chi1(nch1,1:numr1)**2)*step2
        chi1t = sum(chi1this(1:numr1)**2)*step2
	 write(6,350) i2,i3,chi1t,chi1n !,probchi3(i3-ncho+1)
350	 format('    Norm to i2,i3 =',i2,i4,' is ',f9.5,': cumu',f9.5)
	do i=1,nch1
	  do ir=1,numr1
	    write(163,*) real((ir-1)*step2),chi1this(ir)
	  enddo
	  write(163,*) '&'
	 enddo
300     continue
200     continue
	  i1 = nch1
	  chi1norm(i1)=0.d0
	  do ir1=1,numr1
	    chi1norm(i1)=chi1norm(i1)+chi1(i1,ir1)**2*step2
	  enddo
!	write(6,115) ' ',nch1,ni2,ni3,lnames(ly+1),nint(2*tjy),
!     X			chi1norm(i1)
	write(6,116) ' ',tJ2,psign(par2+2),bev,ni3,egs,lnames(ly+1),
     X			nint(2*tjy),  chi1norm(i1)
	write(63,115) '#',nch1,ni2,ni3,lnames(ly+1),nint(2*tjy),
     X			chi1norm(i1)
	write(63,116) '#',tJ2,psign(par2+2),bev,ni3,egs,lnames(ly+1),
     X			nint(2*tjy),  chi1norm(i1)
	write(164,115) '#',nch1,ni2,ni3,lnames(ly+1),nint(2*tjy),
     X			chi1norm(i1)
	write(164,116) '#',tJ2,psign(par2+2),bev,ni3,egs,lnames(ly+1),
     X			nint(2*tjy),  chi1norm(i1)
115	format(a1,'  Overlap<',i2,' * 2b:',I3,' |3b:',i3,' >  : ',a1,i1,
     X		'/2',f10.5,' sq.norm.')
116	format(a1,'  overlap<2b:',f5.1,a1,' @',f8.3,' |3b:',i3,' @',
     X		f8.3,'> = ',a1,i1,'/2 :',f10.5,' sq.norm.')
	ly1(nch1) = ly
	nch1=nch1+1
110     continue
100     continue
	nch1=nch1-1
!	print*,'chi1norms: ',(real(chi1norm(i)),i=1,nch1)
	print*,' '
!	write(62,*) nch1,numr1
!	write(62,*) ((chi1(i1,ir1),ir1=1,numr1),i1=1,nch1)
	do i=1,nch1
		ly = ly1(i) 
		etacns = 0.157
		etap  = (ZN1+ZN2)*0.5 *ZCORE*etacns
	 	eta = 0.5*etap/xk
		rmin = 5.0
	    write(165,*) xk,zn1,zn2,ZCore,etap,eta
	    call flush(165)
	  do ir=1,numr1
	    r = (ir-1)*step2
	   if(r<rmin) then
 	   write(63,*) real(r),real(chi1(i,ir))
	   else
	    IE = 0
	    CALL WHIT(ETA,r,xk,-esep,Ly+1,CF,CG,IE)
 	    asym = CF(ly+1) * exp(-real(IE))
!	    write(165,*) r,CF(ly+1),IE,asym
!	    call flush(165)
 	   write(63,*) real(r),real(chi1(i,ir)),real(chi1(i,ir)/asym),
     x     		asym,IE
	   write(164,*) real(r),real(chi1(i,ir)/asym)
	   endif
	  enddo
	  write(63,*) '&'
	  write(164,*) '&'
	enddo
500     continue
!	call flush(62)
	call flush(63)
	call flush(164)
	call flush(6)
	return
	end
