c
c   F. Nunes & I. Thompson, October 1995, modified IJT, Oct 1999.
c   Calculation of the <two body|three body overlap>
c   for a given 3 body wf in the Y hyperspherical basis, assuming the
c   hyper radial part is normalized  Integral(Xsi^2 dr)=1
c
	Subroutine Overlapp32(nch2,numr2,step2,tJ2,par2,ll2,jj2,ii2,
     &	  MX,chi2, chi3,nch3max,numr3,step3,ncho,nch3,tJ3,par3,jtarg,
     X    egs,kky,lltoty,jstoty,ll1y,ll2y,jjny,iiy, lncmax,
     X 	  a3,xj,wj,njac,pj,mnm,maxl,mlt,ni2,ni3,
     X    ASPL,NYP2,NYMAX,NY,DY)
	implicit real*8 (a-h,o-z)
	real*8 chi2(MX,nch2),chi3(nch3max,numr3),probchi3(nch3max)
	real*8 jj2(nch2),xci(nch2,nch3max)
	integer ll2(nch2),ii2(nch2)
	real*8 xj(njac),wj(njac),pj(0:mnm,0:maxl,-mlt:mlt,njac)
	real*8 tj(njac),jtarg(10),
     X    ASPL(0:NYP2,0:NYMAX) ,USS(nch2),KP,
     X	  FJ(NYP2),W9J(nch3max,nch2)
	integer iiy(nch3max),kky(nch3max),lltoty(nch3max),
     &  jstoty(nch3max),ll1y(nch3max),ll2y(nch3max),jjny(nch3max)
	integer par2,par3,LLX
	logical trace,tracet
        character lnames(8),psign(3)
	data lnames / 's','p','d','f','g','h','i','j' /,
     2     psign / '-',' ','+' / 
	parameter(trace=.false.,tracet=.false.)

	write(10,*) ' Overlapp32: nch2,nch3,ncho,nch3max =',
     X			nch2,nch3,ncho,nch3max
	Z = 0.d0
	NX = numr2
	DX = step2
	AC = A3; AN=1.
	IB2 = nch2
	KP = 0.001
	YMAX = DY*NY
	YMIN = 0.
	UMAX = (1d0-EXP(-KP*YMAX))/KP
	DU   = UMAX/NY
	write(6,10) -2.*KP
10	format(' Using exp(',F6.3,'*rho ) for non-uniform splines')
!      write(10,*) 'Spline coefficients'
!      do 163 j=1,ny
!      write(10,*) j
!      write(10,161) (ASPL(iy,j),iy=1,ny)
!  161 format('#',15f8.4)
!  163 continue
C  Scaling factor for normalisation
C       sqrt(1.144 / DY) for FJ functions,
C	hhjac for r,R -> x,y transformation Jacobean
C	1/sqrt(8d0) from PJ normalisation (with WJ),
C   &   1/sqrt(5d0) from sum of Faddeev components
C	
      SCAL = sqrt(1.144 / DY) / sqrt(8d0) 

        amfacx=Sqrt((AC+AN)/(AC*AN))
        amfacy=Sqrt((AC+AN+AN)/((AC+AN)*AN))
	if(AC.gt.999.) then
           amfacx=Sqrt(1d0/AN)
           amfacy=Sqrt(1d0/AN)
	  endif
        hhjac = (amfacx*amfacy)**1.5

c------------------------------------------------------------
c    Main loop over all Y 3 body channels
c------------------------------------------------------------
	s1=0.5d0
	s2=0.5d0
	lymax=lncmax+int(tJ3)
!	write(6,*)   ' lncmax,lymax =',lncmax,lymax
	nch1 = 0
	do 100 ly=0,lymax
!	  if(trace) write(6,*) 'try ly =',ly,';',(-1)**ly,par2,par3
          if((-1)**ly.ne.par2*par3) goto 100
	do 110 ijy=-1,1,2
	  tjy=ly+s2*ijy
	  if (tjy.lt.0.d0) goto 110
	  if(trace) write(6,*) 'try jy =',tjy,';',tJ2,tJ3
          if (tjy.lt.abs(tJ2-tJ3) .or. tjy.gt.(tJ2+tJ3))
     &    goto 110
!	  write(6,*) 'try ly,tjy =',ly,tjy
!	  write(6,*) 'Triangle tJ2,tjy,tJ3 =',tJ2,tjy,tJ3
	nch1 = nch1+1
c------------------------------------------------------------
c     Algebra
c------------------------------------------------------------
       do 18 IB=1,IB2
	M = IB
	ic = ii2(IB)
	ti = JTARG(ic)
C ****         Y occupied state  of sum(ll2,jj2,ti): (SV,ll2)jj2,ti;tJ2  
C              with overall coupling (SV,ll2)jj2,ti;tJ2 + (ly,SV)tjy  = tJ3
       do 18 i3=ncho,ncho+nch3-1
        L = lltoty(i3)
        LS= jstoty(i3)
        tjn = jjny(i3)
        W9J(i3,M) = Z
           if(ll2(IB).ne.ll1y(i3)) go to 18
           if(ly  .ne.ll2y(i3)) go to 18
           if(ic    .ne.iiy(i3)) go to 18
!           if((-1)**(ly+ll2(IB))*PTARG(ic).ne.NPTY) go to 18
       W9J(i3,M) = sqrt((2*jj2(IB)+1)*(2*tjy+1)*(2*L+1)*(2*LS+1))
     X           * sim9j(S1,   ll2(IB)+Z,jj2(IB),
     X                   S1,   ly+Z,  tjy,
     X                   LS+Z, L+Z,     tjn+Z) 
     X		 * sqrt((2*tjn+1)*(2*tj2+1))
     X		 * RACAH(ti,jj2(IB),tJ3,tjy,tj2,tjn+Z)
     x		 * (-1) ** nint(tJ3 - tj2 + jj2(IB) - tjn)
     X		 * SCAL
18     continue
	    do 35 M=1,IB2
             write(10,30) M,(W9J(i3+ncho-1,M)/SCAL,i3=1,nch3)
30           format(' W9J',I3,'=',8f7.4,:,/(8x,8f7.4))
35	    continue
C **** Now do each spline function              
	chin = 0.
       do 112 J=1,NY
	chi = 0.
	xci(:,:) = 0.
	xni = 0.

c------------------------------------------------------------
c     Calculating the Integral
c------------------------------------------------------------

        do 90 IR=1,numr3
           RO=IR*step3
	   wro = RO**2.5 * step3
        do 90 M=1,NJAC
           xx = XJ(M)
           x = RO * SQRT((1d0-xx)*0.5d0)
           y = RO * SQRT((1d0+xx)*0.5d0)
           XP = x * amfacx
           YP = y * amfacy
!	   write(158,*)  nch1,J,ir,M,':', real(xp),real(yp)
c------------------------------------------------------------
c     Two one-Dimension Interpolation of the 2body WFs
c------------------------------------------------------------
           XR = XP/DX
!	   write(159,*)  nch1,J,ir,M,':', real(xp),real(yp),real(xr)
             IX=XR
		IF(IX+2.gt.NX)  go to 90
             PX=XR-IX
             QX=1.-PX
	    DO 48 IB=1,IB2
   48        USS(IB)=QX*chi2(IX+1,IB)+PX*chi2(IX+1+1,IB)

	YP = YP - YMIN
		IF(YP<0.)  go to 90
	UP = (1 - EXP(-KP*YP))/KP
	UR = UP/DU
	YR = UR
             IY=YR
             PY=YR-IY
             QY=1.-PY
           JY=J
           FJ(JY)=0.0
           IF(IY.LE.NY)
     X      FJ(JY)=-(ASPL(IY,JY)*QY*(1.-QY*QY)+
     X               ASPL(IY+1,JY)*PY*(1.-PY*PY))
   50      continue
           IF(IY.eq.J.and.IY.GT.0.and.IY.le.NY)FJ(IY  )=FJ(IY  )+QY
           IF(IY+1.eq.J.and.IY.LT.NY)          FJ(IY+1)=FJ(IY+1)+PY
		SCY = sqrt(DU/DY)*exp(KP*0.5*YP)
		if(IY==NY)write(160+IY,55) YP+YMIN,FJ(J),IY,NY
   55		format(f8.2,f12.6,2i4)
           SS = WJ(M) * FJ(J)/(YP+YMIN)  * hhjac *SCY * wro

!	   write(160,*)  nch1,J,ir,M,':', real(SS) 

	   L2=ly
        do 70 i3=ncho,ncho+nch3-1
	   L1=ll1y(i3)
	   NN = mod(L1+L2,2)
	   LD=(L1-L2+NN)/2
	   if(abs(ld)>mlt) go to 70
	   N=(kky(i3)-L1-L2)/2
           S = SS * pj(N,L1,LD,M) 
!	   write(160,*)  nch1,J,ir,M,i3,':', real(S)
	    DO 60 IB=1,IB2
              T = S * USS(IB) * W9J(i3,IB)
              TT = T * chi3(i3,IR)
	      xci(ib,i3-ncho+1) = xci(ib,i3-ncho+1) + abs(TT)
	      xni = xni + T*T
   60        chi = chi + TT 
   70    continue
   90    continue
        write(10,*) ' Norm of spline state ',J,' is ',real(xni)
	do 94 ib=1,IB2
        write(10,*) ' Contributions from ib= ',IB
   94	write(10,95) (xci(ib,i3),i3=1,nch3)
   95	format(8f10.5)
!	 write(6,350) IY,chi,chi**2
!350	 format('    overlap,norm to i2,iy,i3 =',i2,i3,i4,' is ',2f10.5)
	write(6,115) nch1,J,ni2,ni3,lnames(ly+1),nint(2*tjy),chi
115	format('  overlap<',i2,'* y:',I2,' * 2:',I3,' |3:',i3,' >  : ',
     X		a1,i1,'/2 =',f10.5)
	chin = chin + chi**2
		if(IY==NY)write(160+IY,55) '&'
112     continue
	write(6,111) nch1,ni2,ni3,lnames(ly+1),nint(2*tjy),
     x		chin,sqrt(chin)
111	format('  Overlap<',i2,'* all y * 2:',I3,' |3:',i3,' >  : ',
     X		a1,i1,'/2 =',2f10.5,' sq.,norm.')
110     continue
100     continue
500     continue
	call flush(6)
	return
	end
