	SUBROUTINE QUALAG(X,W,N,AL)
C GAUSS-LAGUERRE QUADRATURE FORMULAS
C AL IS AN INTEGER NUMBER
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	COMMON /FACT/DLFAC,DL2FAC
	DIMENSION X(N),W(N),dlfac(0:200),dl2fac(0:200)
	Y=1.
	EPS=1.E-13
C INITIAL VALUES FOR NODES
	H=.05d0/N
	F=2.d0*N+AL+1.d0
	G=F+DSQRT(F*F+.25d0-AL*AL)
	M=G/H+1
	J=0
	DO 1 I=1,M
	Z=H*I
	V=POLAG(N,AL,Z)
	C=V/Y
	IF(C.LT.0) THEN
	J=J+1
	X(J)=Z
	END IF
1	Y=V
C	WRITE(6,*)J
C EXACT NODES
	DO 2 I=1,N
	XS=X(I)
	CALL ROOTLAG(XS,Y,EPS,N,AL)
2	X(I)=Y
C THE WEIGHTS
	LAL=AL
	S=DEXP(DLFAC(N+LAL)-DLFAC(N+1))/(N+1)
	DO 3 I=1,N
	A=X(I)
	B=POLAG(N+1,AL,A)
3	W(I)=S*X(I)/(B*B)
	RETURN
	END
