      SUBROUTINE RRCOE(K,L,L1,L2)
C****  R.R. COEFFICIENTS OR HYPERSPH. BRACKETS ARE CALCULATED HERE
C****  WITH THE HELP OF EQS. (28),(47) IN YAD.FIZ. 17(1973)210 .
C****  L1 AND L2 ARE JACOBI MOMENTA.TWO JACOBI MOMENTA IN AN ANOTHER
C****  PAIR ARE DESIGNATED BELOW AS L11 AND L21. BRACKETS WITH ALL
C****  POSSIBLE L11,L12 VALUES AT GIVEN K,L,L1,L2 ARE CALCULATED.

C****   Version (April 1996, IJT) to handle C=0, T=Inf

      IMPLICIT DOUBLEPRECISION(A-H,O-Z)
      COMMON/ROT/C,S,T,A(499,29),J1,J
      COMMON/FACT/ DLFAC,DL2FAC
C****    QUANTITIES C,S,T,A,J1,J,DLFAC AND DL2FAC ARE DEFINED
C****  AS FOLLOWS.
C****  C = COS(FI), S = SIN (FI), T = TAN(FI) WITH
C****  KSI11 = C*KSI1+S*KSI2, KSI21 = S*KSI1-C*KSI2, SEE EQ.(6)
C****  IN YAD.FIZ. 17(1973)210. THE H.H. ARE DEFINED AS IN EQS.
C****  (1) - (4) IN THAT PAPER.
C      A = A(M,N) IS A REQUIRED ARRAY OF BRACKETS WITH GIVEN K,L,L1,L2
C      VALUES. M AND N VARIABLES SPECIFY
C      OTHER PAIR OF JACOBI MOMENTA L11 AND L21 AS FOLLOWS
C      L11 = .5*(K-(L-NN))+N-M, L21 = .5*(K+(L-NN))-N-M+2.
C      THE NN VALUE EQUALS 0 IF K-L IS EVEN AND 1 OTHERWISE.
C      THE M AND N VARIABLES TAKE ALL THE INTEGER VALUES FROM
C      UNITY TO J1=.5*(K-L-NN)+1 AND J=L-NN+1 CORRESPONDINGLY
C      THAT GIVES ALL THE L11 AND L12 VALUES PERMISSIBLE
C****  AT GIVEN K,L,L1 AND L2.
C****  DLFAC(N)=LN(N!), DFACL(N)=LN((2N+1)!!).
      DIMENSION B(499,29),DLFAC(0:200),DL2FAC(0:200)
C****  THE B ARRAY IS AN AUXILIARY ONE.
C****  DIMENSIONS OF ARRAYS A(I1,I) AND B(I1,I) SHOULD BE NOT LESS
C****  THAN I1=J1=.5(K-L-NN)+1 AND I=J = L-NN+1 WITH J1 AND J DEFINED
C****  ABOVE.
      AL(JP,JQ,LX) =DSQRT((JP+JQ+LX)*(JP+JQ+LX+1.D0)*(JP+JQ-LX)*
     1(JP+JQ-LX-1.D0)/((2.D0*JP-1.D0)*(2.D0*JP+1.D0)*(2.D0*JQ-1.D0)*
     2(2.D0*JQ+1.D0)))
      BE(JP,JQ,LX) = DSQRT((LX+JP-JQ+1.D0)*(LX+JP-JQ+2.D0)*(LX+JQ-JP)*
     1(LX+JQ-JP-1.D0)/((2.D0*JP+1.D0)*(2.D0*JP+3.D0)*(2.D0*JQ-1.D0)*
     2(2.D0*JQ+1.D0)))

C  EQ.(48) ***********************************************
C            CALCULATION OF BR.OF EQ.(28)
      P1=DSQRT((2.D0*L1+1.D0)*(2.D0*L2+1.D0))
      P=DLFAC(L1+L2+1)+.5D0*(DLFAC(L1+L2+L+1)+
     1DLFAC(L1+L2-L))
      NNKL=K-L
      NN = NNKL-2*(NNKL/2)
      IF(NNKL) 31,30,30
  31  WRITE(6,40) K,L
      STOP
  30  LDIF=IABS(L1-L2)
      IF(L1+L2-L) 32,33,33
  32  WRITE(6,41) L1,L2,L
      STOP
  33  IF(L1+L2-K) 35,35,34
  34  WRITE(6,42) L1,L2,K
      STOP
  35  KPAR=K-2*(K/2)
      L12PAR=L1+L2-2*((L1+L2)/2)
      IF(KPAR-L12PAR) 36,37,36
  36  WRITE(6,43) L1,L2,K
  40  FORMAT(' CHECK K AND L VALUE. K=',I4,' L=',I4)
  41  FORMAT(' CHECK L1,L2 AND L VALUE. L1=',I4,' L2=',I4,' L=',I4)
  42  FORMAT(' CHECK L1,L2 AND K VALUE. L1=',I4,' L2=',I4,' K=',I4)
  43  FORMAT(' CHECK PARITY L1+L2 & K. L1=',I4,' L2=',I4,' K=',I4)
      STOP
  37  IF(L-LDIF) 32,38,38
  38  LL = L-NN
      J1 = (L1+L2-L-NN)/2 +1
      J  = LL+1
	if(abs(C).le.1.1e-6) go to 90
      DO 1 M=1,J1
      DO 1 N=1,J
      L11 = (L1+L2-LL)/2+N-M
      L21 = (L1+L2+LL)/2-N-M+2
      LS1  = (L1+L2-L11-L21)/2
      LT1  = (L1+L2+L11+L21)/2
      Q1=DSQRT((2.D0*L11+1.D0)*(2.D0*L21+1.D0))
      Q=DLFAC(LS1)+DLFAC(LT1+1)+DL2FAC(LS1+L11)+DL2FAC(LS1+L21)
C EQ.(29)    *************************************************
      F  = 0.000D0
      LP1 = L1-LS1
      LQ1 = L2-LS1
      I1 = IABS(LP1-L11)+1
      I2 = MIN0(LP1+L11,LQ1+L21)+1
      DO 2 MM=I1,I2,2
      LZ1  = L11-MM+1
      LZ2  = MM-L21-1
      LX1  = (LP1+LZ1)/2
      LX2  = (LP1-LZ1)/2
      LX3  = (LQ1+LZ2)/2
      LX4  = (LQ1-LZ2)/2
	if(abs(LP1-LQ1).gt.L .or. LP1+LQ1.lt.L .or.
     x     abs(LZ1).gt.LP1   .or. abs(LZ2).gt.LQ1) go to 2
      F=F+(-1)**LX4*DEXP(.5*(DLFAC(2*LX1)+DLFAC(2*LX2)+
     1DLFAC(2*LX3)+DLFAC(2*LX4))-DLFAC(LX1)-DLFAC(LX2)-
     2DLFAC(LX3)-DLFAC(LX4))*T**(MM-1)*
     3 WIG(2*LP1,2*LQ1,2*L,2*LZ1,2*LZ2)
 2    CONTINUE
      I   = -(L11+L21)
      A(M,N)=S**LS1*C**LT1*2.D0**I*P1*Q1*DEXP(P-Q)*F
 1    B(M,N) = A(M,N)
      K1  = L1 + L2 +2
      IF(K-K1)25,4,4
 4    C2  = C**2 -S**2
      S2  = S*C
C  EQ. (47), SEE LABEL 19 IN BELOW  ***************************
      DO 5 I=K1,K,2
      J1   = J1 +1
      LP11  = (I-LL)/2
      LP21  = (I+LL)/2
      DO 6 M=1,J1
      DO 6 N=1,J
      L11  = LP11+N-M
      L21  = LP21 -N-M+2
      IF(M-2) 7,8,9
 7    A1   = 0.0000000
      A3   = 0.0000000
      A4   = 0.0000000
      A5   = 0.0000000
      GO TO 10
 8    A3   = 0.0000000
      GO TO 11
 9    A3   = B(M-2,N)*AL(L11+1,L21+1,L)
 11   A1   = B(M-1,N)
      IF(N-1)12,12,13
 12   A5   = 0.00000000
      GO TO 14
 13   A5   = B(M-1,N-1)*BE(L21,L11,L)
 14   IF(J-N) 15,15,16
 15   A4   = 0.00000000
      GO TO 10
 16   A4   = B(M-1,N+1)*BE(L11,L21,L)
 10   IF(J1-M) 17,17,18
 17   A2   = 0.0000000
      GO TO 19
 18   A2   = B(M,N)*AL(L11,L21,L)
 19   A(M,N) = C2*A1+S2*(A2-A3+A4-A5)
  6   CONTINUE
      DO 26 M=1,J1
      DO 26 N=1,J
      B(M,N) = A(M,N)
  26  CONTINUE
  5   CONTINUE
C  EQ.(12) *********************************************************
 25   CCC   =.5D0*(DLFAC((K-L1-L2)/2)+
     1DLFAC(1+(K+L1+L2)/2)+DL2FAC((K-L1+L2)/2)+
     2DL2FAC((K+L1-L2)/2))
      LP11  = (K-LL)/2
      LP21  = (K+LL)/2
      DO 20 M=1,J1
      DO 20 N=1,J
      L11  = LP11+N-M
      L21  = LP21-N-M+2
      FAFUN   =.5D0*(DLFAC((K-L11-L21)/2)+
     1DLFAC(1+(K+L11+L21)/2)+DL2FAC((K-L11+L21)/2)+
     2DL2FAC((K+L11-L21)/2))
      A(M,N)=A(M,N)*DEXP(FAFUN-CCC)
 20   CONTINUE
	if(J1.gt.499.or.J.gt.29) then
		write(6,*) J1,J,' needed in RRCOE'
      		write(6,*)  'K,L,L1,L2',K,L,L1,L2
		stop 'RRCOE'
	endif
      RETURN
90    K1  = L1 + L2 +2
      DO 91 I=K1,K,2
91    J1   = J1 +1
      do 95 M=1,J1
      do 95 N =1,J
	A(M,N) = 0.0
      L11 = (K-LL)/2+N-M
      L21 = (K+LL)/2-N-M+2
95    if(L11.eq.L2.and.L21.eq.L1) a(M,N) = (-1)**((K+L1+L2)/2 - L)
     x		* nint(S)**K1
      END
